(function () {
    "use strict"

    angular.module('starter')
    .controller('account', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', 'utility','$ionicHistory','nativeHelper', function ($rootScope, $scope, nav, localStorage, control, utility,$ionicHistory, nativeHelper) {
        $scope.showLogOff = false;
        // 是否显示注销
        var showLogOffFunc = function () {
            console.log('$rootScope.loginInfo.mobile - ' + $rootScope.loginInfo.mobile);
            if ('18324450217' == $rootScope.loginInfo.mobile) {
                $scope.showLogOff = true;
            }
        }
        showLogOffFunc();

        $scope.callService = function () {
            utility.callService();
        }

        $scope.navToHelp = function () {
            if (!cordova.InAppBrowser) { return; }

            var operation = 'location=no,toolbartranslucent=yes,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=yes,toolbarposition=top,closebuttoncaption=<,iscustomnav=yes,title=' + '移动证书';
            cordova.InAppBrowser.open(window.currentUrl + '/app/api/apphelp', '_blank', operation);
        };

        $scope.signOut = function () {
            var confirm = function () {
                $rootScope.localCertList = [];
                localStorage.deleteItem('loginInfo');

                PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
                $ionicHistory.clearHistory();
                nav.navigate('signIn');

                if ('android' == cordova.platformId) {
                    var params = [];
                    var successFunc = function (result) {}
                    var failFunc = function (error) {}
                    nativeHelper.signOut({data: params, success: successFunc, fail: failFunc});
                }

            };
            var cancel = function () { };

            control.showConfirm('确定要退出当前账号登录？', confirm, cancel);
        };

        $scope.logOff = function () {
            var confirm = function () {
                localStorage.setObject('logOff', '1');
                
                $rootScope.localCertList = [];
                localStorage.deleteItem('loginInfo');
                PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
                $ionicHistory.clearHistory();
                nav.navigate('signIn');
            };
            var cancel = function () { };

            control.showConfirm('确定要注销当前账号吗？', confirm, cancel);
        };

        $scope.informationPush = function () {
            var confirm = function () {};
            var cancel = function () {};
            control.showConfirm('请选择关闭或打开信息推送', confirm, cancel,'关闭','打开');
        };

        var puchSwitch = function() {
            let ele = document.getElementById('switch-push');
            let openPush = localStorage.getObject('openPush');
            if ('1' == openPush) {
                ele.checked = true;
            } else {
                ele.checked = false;
            }
        }
        puchSwitch();
        
        $scope.pushClick = function() {
            let ele = document.getElementById('switch-push');
            if(ele.checked == true){
                localStorage.setObject('openPush', '1');
            } else {
                localStorage.setObject('openPush', '0');
            }
        }

        $scope.infoClick = function(type) {
            var host = 'http://115.238.48.66:8085';
            var url = '';
            if ('personal' == type) {
                url = host + '/app/personal-information-collection.html';
            } else if ('third' == type) {
                url = host + '/app/third-party-information-sharing.html';
            }
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }

        $scope.agreement = function(type) {
                if (type === 'appagreement') {
                    var url = window.currentUrl + '/app/api/appagreement';
                } else {
                    var url = window.currentUrl + '/app/api/appprivacy';
                }

                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }
         //演示视频
         $scope.operationVideo=function(){
//            var url = 'https://b23.tv/KR8Hmo';
//            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
//            cordova.InAppBrowser.open(url, '_system', operation);
         }
        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();
