(function() {
    "use strict"

    angular.module('starter').
    controller('downloadCertSuccess', ['$rootScope', '$scope', '$state', 'nav', 'control', 'nativeHelper', 'validate', 'verifyIdentity', '$stateParams',
    function($rootScope, $scope, $state, nav, control, nativeHelper, validate, verifyIdentity, $stateParams) {

        var downloadSuccessInfo = $stateParams.downloadSuccessInfo;

        $scope.isExistValidAdmin = false;

        //查询是否存在有效管理员
        var checkIsExistValidAdmin = function() {

            control.showLoading();
            var params = [downloadSuccessInfo.uniscid];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                }
                if (result.rslt == 'success') {
//                "existValidAdmin":"0不存在1存在"
                    if (result.existValidAdmin == '0') {
                        $scope.isExistValidAdmin = true;
                    }
                }

                if (result.rslt == 'fail') {
                    control.showPopup(result.errorMsg, 2000);
                }
            }
            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
                return '';
            };
            nativeHelper.existValidAdmin({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
        var identityId;
        var checkIdentityRes = function(result) {
            if (result.rslt == 'success') {
                $scope.identityType = result.identityType; //0法定代表人1管理员2经办人
                 identityId=result.identityId
                if (result.identityType == '0') checkIsExistValidAdmin();
            }
            if (result.rslt == 'fail') {}
        }
        //核验身份
        verifyIdentity.checkIdentity(downloadSuccessInfo.uniscid, downloadSuccessInfo.operatorId, '2', checkIdentityRes);

        $scope.openWeChat = function() {
            var successFunc = function(result) {
            }

            var failFunc = function(error) {
//                console.log(error);
                control.showPopup('分享失败,请选择复制', 2000);
            };

            nativeHelper.socialAgent({
                data: ["e照通", 2],
                success: successFunc,
                fail: failFunc
            });
        }

        $scope.setAdmin = function() {
            $state.go('addAdmin', {
                'certEntInfo':{'uniscid':downloadSuccessInfo.uniscid,'authIdentityId':identityId}
            });
        }
//         var eventWithParameters = function() {
//          var eventCounter = new Object();
//          eventCounter.page = "证书下载成功";
//          MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//         }
        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
