﻿﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('authorityCenter', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper',
            function ($rootScope, $scope, nav, control, nativeHelper) {
//230606199308086125
                $scope.authority = { IDCardName: "", IDCardNumber: "" }

                var enterAuthorityCenter= function(params){
                    if(cordova.platformId==='android'){
                          var operation = 'location=no,toolbar=yes,toolbarposition=top,toolbarType=title,certList='+JSON.stringify($rootScope.localCertList);
                          }else{
                                var operation = 'location=no,toolbar=no,toolbarposition=top,toolbarType=title,clearcache=no,clearsessioncache=no';
                           }
						   //测试环境
                           //var url="http://192.168.1.237:8886/acAccount/faceResult?param="+params
						   //正式环境
						   var url="http://118.178.118.156/acAccount/faceResult?param="+params
                          cordova.InAppBrowser.open(url, '_blank', operation);
                }
                var startAuthority = function () {
                    control.showLoading();
                    var params = ["1","{\"name\":\""+$scope.authority.IDCardName+"\",\"cert\":\""+$scope.authority.IDCardNumber+"\",\"mobile\":\""+$rootScope.loginInfo.mobile+"\"}" ];
                        var successFunc = function (result) {
                            control.hideLoading();
                            enterAuthorityCenter(encodeURIComponent(result));
                        }
                        var failFunc = function (result) {
                            control.hideLoading();
                            control.showPopup(result.msg, 2000);
                        };
                        nativeHelper.getEncryptAndDecryptStr({ data: params, success: successFunc, fail: failFunc });

                };
                var authorityCenterResult = function (e) {

                    if (cordova.platformId === 'ios' && e.ytErrorcode == 'back') return;

                    $scope.$apply(function () {
                        if (e.ytErrorcode == "0") {
                            startAuthority();
                        } else {
                            control.showPopup(e.ytErrormsg, 2000);
                        }
                    });
                };

                window.broadcaster.addEventListener("authorityCenterResult", authorityCenterResult);
                var navToAuthView = function () {
                    var timeout = setTimeout(function () {
                        clearTimeout(timeout)

                        var params = [
                            $scope.authority.IDCardName,
                            $scope.authority.IDCardNumber,
                            $rootScope.loginInfo.mobile,
                            $rootScope.loginInfo.userId,
                            'authorityCenterResult',
                        ];
                        var successFunc = function (result) {

                        }
                        var failFunc = function (result) {
                            control.showPopup(result.msg, 2000);
                        };
                        nativeHelper.navToAuthView({ data: params, success: successFunc, fail: failFunc });
                    }, 50);
                }

                $scope.next = function() {
                    if ($scope.authority.IDCardName == '') {
                        control.showPopup('姓名不能为空', 2000);
                        return;
                    }
                    if ($scope.authority.IDCardNumber == '') {
                        control.showPopup('身份证号码不能为空', 2000);
                        return;
                    }

                    if ($scope.authority.IDCardNumber.length === 17) {
                        $scope.authority.IDCardNumber.length += "X";
                    }
                    //                    startAuthority();
                    navToAuthView();
                }
                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();