﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('authorityConfirm', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper','$stateParams',
         function ($rootScope, $scope, nav, control, nativeHelper,$stateParams) {
                //获取经办人信息
                var cardId = $stateParams.cardId;
                var cardName = $stateParams.cardName;
            /**
            *获取授权信息
            **/
            var getAuthorizationComfirmInfo=function(){
             control.showLoading();
             /**
             *参数一："type":"鉴权类型：1：根据事项编码身份信息鉴权；2：根据事项编码授权码鉴权；3：根据
             *        事项编码，身份信息，授权码鉴权；4：根据单位信息鉴权"。
             *参数二："itemCode":"事项编码"。
             *参数三："certKey":"身份证件号码的SM3hash值",js端将身份证信息传给native进行摘要。
             **/
             var params = ["1","20191016172831442090",cardId,$rootScope.searchResult.entName,$rootScope.searchResult.uniscid ];
//             var params = ["1","20190325092052817016",cardId,"玉环金源进出口有限公司","913310217719107159" ];
                            var successFunc = function (result) {
                              control.hideLoading();
                                if(result.rslt =='success'){
                                 $scope.$apply(function () {
                                if(result.checkData.checkRslt=="true"){
                                        $scope.checkRslt=true;
                                        var authAllContent=result.authInfoData.authContent;
                                        var content=authAllContent.split("。");
                                        $scope.authContent=content[0];
                                        $scope.AuthPeriod=content[1];
                                        $scope.authName=result.authInfoData.authName;
                                        $scope.time=result.authInfoData.time;
                                }else
                                $scope.checkRslt=false;
                               });
                                }else{
                                $scope.checkRslt=false
                                control.showPopup(result.errorMsg, 2000);
                                }
                            }
                            var failFunc = function (result) {
                                control.hideLoading();
                                 $scope.checkRslt=false
                                control.showPopup(result.msg, 2000);
                            };
                            nativeHelper.getAuthorizationComfirmInfo({ data: params, success: successFunc, fail: failFunc });
            }
            getAuthorizationComfirmInfo();

            $scope.createOrders = function () {
                    control.hideLoading();
                var params = [cardName,
                             cardId,
                             $rootScope.loginInfo.mobile,
                             $rootScope.loginInfo.accountId,
                             $rootScope.certUnderwayInfo.corpid,
                             $rootScope.certUnderwayInfo.categoryBh,
                             $rootScope.certUnderwayInfo.businessCode];
                var successFunc = function (result) {
                    control.hideLoading();
                    if(result.success){
                        nav.navigate('authorizedApplyComplete');
                    }else{
                     control.showPopup(result.msg, 2000);
                    }
                }
                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.createOrders({ data: params, success: successFunc, fail: failFunc });
            }
            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
