﻿﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('authorizedPerson', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper','$state',
         function ($rootScope, $scope, nav, control, nativeHelper,$state) {

        $scope.authorizedPerson={IDCardName: "", IDCardNumber: ""}


            var showAuthResult = function (e) {

                if (cordova.platformId === 'ios' && e.ytErrorcode == 'back') return;

                $scope.$apply(function () {
                    if (e.ytErrorcode == "0") {
                         $state.go('authorityConfirm', { cardId: $scope.authorizedPerson.IDCardNumber,
                                                     cardName:$scope.authorizedPerson.IDCardName});
                    } else {
                        control.showPopup(e.ytErrormsg, 2000);
                    }
                });
            };

            window.broadcaster.addEventListener("showAuthorityApplyResult", showAuthResult);
            var navToAuthView = function () {

            var timeout = setTimeout(function () {
              clearTimeout(timeout)
                var params = [
                    $scope.authorizedPerson.IDCardName,
                    $scope.authorizedPerson.IDCardNumber,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.userId,
                    'showAuthorityApplyResult',
                ];
                var successFunc = function (result) {

                }
                var failFunc = function (result) {
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.navToAuthView({ data: params, success: successFunc, fail: failFunc });
                 }, 50);
            }

            $scope.next = function() {
                if ($scope.authorizedPerson.IDCardName == '') {
                    control.showPopup('姓名不能为空', 2000);
                    return;
                }
                if ($scope.authorizedPerson.IDCardNumber == '') {
                    control.showPopup('身份证号码不能为空', 2000);
                    return;
                }

                if ($scope.authorizedPerson.IDCardNumber.length === 17) {
                    $scope.authorizedPerson.IDCardNumber += "X";
                }
                //                     $state.go('authorityConfirm', { cardId: $scope.authorizedPerson.IDCardNumber,
                //                              cardName:$scope.authorizedPerson.IDCardName});
                navToAuthView();
            }
            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();