(function () {
    "use strict"
    angular.module('starter')
        .controller('businessCompleted', ['$rootScope', '$scope', 'nav', '$stateParams','nativeHelper','control',function ($rootScope, $scope, nav,$stateParams,nativeHelper,control) {

            $scope.orderNo=$stateParams.orderNo;
            $scope.navigate = function (state) {
                $rootScope.isNeedAuthFace = true;
                nav.navigate(state);
            };
  $scope.openWeChat = function() {
      var successFunc = function(result) {}

      var failFunc = function(error) {
          //                console.log(error);
          control.showPopup('分享失败,请选择复制', 2000);
      };

      nativeHelper.socialAgent({
          data: ["e照通", 2],
          success: successFunc,
          fail: failFunc
      });
  }

      /**
       *撤销邮寄业务单
       *撤销完成跳转到授权领证搜索页面
       **/
  $scope.doCancelNetOrder = function() {
      control.showLoading();
      var params = [$scope.orderNo];
      var successFunc = function(result) {
          control.hideLoading();
          $scope.postTipDialog = true;
          $scope.mainCert = false;
          $scope.otherCert = false;
          if (result == null || angular.equals({},
          result)) {
              control.showPopup('服务出错啦', 2000);
              return;
          };
          switch (result.success) {
          case true:
              $scope.$apply(function() {
                  nav.go('applyCertSearch');
              });
              break;
          case false:
              control.showPopup(result.msg, 2000);
              break;
          }
      };

      var failFunc = function(result) {
          control.hideLoading();
          control.showPopup(result.msg, 2000);
      };

      nativeHelper.doCancelNetOrder({
          data: params,
          success: successFunc,
          fail: failFunc
      });
  };
        }]);
})();
