(function () {
    "use strict"
    angular.module('starter')
        .controller('checkIdentityCard', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'utility', 'verifyIdentity','$state','localStorage',function ($rootScope, $scope, nav, control, nativeHelper, utility,verifyIdentity,$state,localStorage) {

           if(cordova.platformId==='android'){
                $scope.isAndroid=true;
           }else{
                $scope.isAndroid=false;
           }
        $scope.checkPicture = function (type) {

                var successFunc = function (pic) {
                 control.hideLoading();
                    if(type=="1"){
                     $rootScope.autoApplyInfo.IDCardFrontPic = 'data:image/png;base64,' + pic;
//                     checkIdentityCard(pic, type);
                    }else if(type=="2"){
                      $scope.$apply(function () {
                        $rootScope.autoApplyInfo.IDCardBackPic = 'data:image/png;base64,' + pic;
//                        checkIdentityCard(pic, type);
                      });
                    }
                };

                var failFunc = function (e) {
                 control.hideLoading();
                };
                control.camera(successFunc, failFunc, false);
            }

        var OCRFail=function(card_type){
            var OCRFailMsg = '图像识别失败';
                control.showConfirm(OCRFailMsg,
                  function () {
                          return;
                          },
                       function () {
                         $scope.checkPicture(card_type);
                       return;
                          }, "重拍", "取消", 'cusClass');
                }

            var checkIdentityCard = function (image, card_type) {
                control.showLoading();
                var timeout = setTimeout(function () {
                    var time_stamp = Date.parse(new Date()).toString().substr(0, 10);
                    var nonce_str = utility.randomStr(true, 3, 32);
                    var sign = utility.getReqSign({
                        app_id: $rootScope.configInfo.ocrAppId,
                        time_stamp: time_stamp,
                        nonce_str: nonce_str,
                        image: image,
                        card_type: card_type
                    });
                    var params = [ image, card_type];
                    var successFunc = function (result) {
                        clearTimeout(timeout)
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
//                             $rootScope.OCRFailMsg = '图像识别失败，请重试';
//                             $rootScope.OCRFail();
//                          OCRFail(card_type);
                            return;
                        }

                        if (result.retcode == "0") {
                            if (card_type == "1") {
                                $scope.$apply(function () {
                                    var pic =  image
                                    $rootScope.autoApplyInfo.IDCardFrontPic = 'data:image/png;base64,' + pic;
                                    $scope.checkIdentityCard.IDCardName = result.retvalue.name.replace(/\s+/g, '');
                                    $scope.checkIdentityCard.IDCardNumber = result.retvalue.cardno.replace(/\s+/g, '');
                                });
                            }
                            else {
                                $scope.$apply(function () {
                                    var pic =  image
                                    $rootScope.autoApplyInfo.IDCardBackPic = 'data:image/png;base64,' + pic;
                                    $rootScope.autoApplyInfo.IDCardIndate = result.retvalue.deadline.replace(/\s+/g, '');
                                });
                            }
                        }
                        else {
                            //$rootScope.OCRFailMsg = result.msg;
//                            $rootScope.OCRFailMsg = '图像识别失败，请重试';
//                            $rootScope.OCRFail();
//                                OCRFail(card_type);
                        }
                    }

                    var failFunc = function (result) {
                        clearTimeout(timeout)
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.checkIdentityCard({ data: params, success: successFunc, fail: failFunc });
                }, 500);
            };


            //生成业务单
            var doSaveAutoAuditNetOrderInfo = function () {

                control.showLoading();
                console.log("doSaveAutoAuditNetOrderInfo info:" + JSON.stringify($rootScope.certUnderwayInfo));
                var params = [
                    $rootScope.autoApplyInfo.IDCardName,
                    $rootScope.autoApplyInfo.IDCardNumber,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.accountId,
                    $rootScope.certUnderwayInfo.categoryBh,
                    $rootScope.certUnderwayInfo.businessCode,
                    '5',
                    $rootScope.certUnderwayInfo.netType,
                    $rootScope.certUnderwayInfo.entName,
                    $rootScope.certUnderwayInfo.uniscid,
                    $rootScope.certUnderwayInfo.corpid,
                    {
                        businessLicense: $rootScope.autoApplyInfo.businessLicensePic,
                        letter: $rootScope.autoApplyInfo.authorizationPic,
                        idCardFace: $rootScope.autoApplyInfo.IDCardFrontPic,
                        idCardBack: $rootScope.autoApplyInfo.IDCardBackPic,
                        faceBase64: photoData==''?photoData:"data:image/png;base64,"+photoData
                    },
                    '0',//是否通过ocr校验0：不通过，1：已通过
                    $rootScope.autoApplyInfo.facePassState//人脸识别是否通过状态：0通过，1不通过

                ];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
                        //订单号
                        $scope.$apply(function () {
                            $rootScope.curAutoApplyOrderNo = result.value.orderNo;
                            if($rootScope.autoApplyInfo.facePassState==='0'){
                                $state.go('businessCompleted',{orderNo:result.value.orderNo});
                            }else
                             $state.go('postIntroduction',{orderNo:result.value.orderNo});

                        });
                    }
                    else {
                      $rootScope.OCRFailMsg =result.msg;
                      $rootScope.OCRFail();
                    }
                }
                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.doSaveAutoAuditNetOrderInfo({ data: params, success: successFunc, fail: failFunc });
            };

            var showAuthResult = function (e) {
                if (cordova.platformId === 'ios' && e.ytErrorcode == 'back') return;

                $scope.$apply(function () {
                    if (e.ytErrorcode == "0") {

                            doSaveAutoAuditNetOrderInfo();
                    } else {
                        control.showPopup(e.ytErrormsg, 2000);
                    }
                });
            };

            window.broadcaster.addEventListener("showAuthResult", showAuthResult);
            var navToAuthView = function () {
                var params = [
                    $rootScope.autoApplyInfo.IDCardName,
                    $rootScope.autoApplyInfo.IDCardNumber,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.userId,
                    'showAuthResult',
                ];
                var successFunc = function (result) {

                }
                var failFunc = function (result) {
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.navToAuthView({ data: params, success: successFunc, fail: failFunc });
            }
            $scope.remake=function(){
                $rootScope.autoApplyInfo.IDCardFrontPic='',
                $rootScope.autoApplyInfo.IDCardBackPic='',
                $rootScope.autoApplyInfo.IDCardName='',
                $rootScope.autoApplyInfo.IDCardNumber=''
            }

            $scope.checkIdentityCard={IDCardName:$rootScope.loginInfo.userName?$rootScope.loginInfo.userName:'',IDCardNumber:$rootScope.loginInfo.idCard?$rootScope.loginInfo.idCard:''}
            $scope.inputable=false;//默认允许输入框可输入
            if($rootScope.loginInfo.userName){
                $scope.inputable=true;
            }
            //采集人脸提示
            $scope.alert_applicant_info=false;
            $scope.next = function () {


                if ($rootScope.autoApplyInfo.IDCardFrontPic == '' || $rootScope.autoApplyInfo.IDCardBackPic == '') {
//                    $rootScope.OCRFailMsg = '请上传身份证正反面';
//                    $rootScope.OCRFail();
                    control.showPopup("请上传身份证正反面", 2000);
                    return;
                }

                //alert('身份证信息：' + $rootScope.autoApplyInfo.IDCardName + '\r\n' + '委托书信息：' + $rootScope.autoApplyInfo.authorizationPerson)
                //alert('身份证信息：' + $rootScope.autoApplyInfo.IDCardNumber + '\r\n' + '委托书信息：' + $rootScope.autoApplyInfo.authorizationID);
                //if ($rootScope.autoApplyInfo.IDCardName !== $rootScope.autoApplyInfo.authorizationPerson) {
                //    $rootScope.infoMismatchMsg = '姓名与授权书姓名不一致，请核对委托书、身份证后重新上传';
                //    $rootScope.infoMismatch();
                //    $scope.isClicked = false;
                //    return;
                //}

                //if ($rootScope.autoApplyInfo.IDCardNumber !== $rootScope.autoApplyInfo.authorizationID) {
                //    $rootScope.infoMismatchMsg = '身份证号与授权书身份证号不一致，请核对委托书、身份证后重新上传';
                //    $rootScope.infoMismatch();
                //    $scope.isClicked = false;
                //    return;
                //}

                if ($scope.checkIdentityCard.IDCardName == '') {
//                    $rootScope.infoMismatchMsg = '身份证识别失败，请重新上传';
//                    $rootScope.infoMismatch();
                    control.showPopup("姓名错误请修改", 2000);
                    $scope.isClicked = false;
                    return;
                }

                if ($scope.checkIdentityCard.IDCardNumber == '') {
//                    $rootScope.infoMismatchMsg = '身份证识别失败，请重新上传';
//                    $rootScope.infoMismatch();
                    control.showPopup("身份证号码错误请修改", 2000);

                    return;
                }
                if($scope.checkIdentityCard.IDCardNumber.length===17){
                    $scope.checkIdentityCard.IDCardNumber+="X";
                }
//                if($rootScope.loginInfo.realNameGrade=='1'){
//                   if ($scope.checkIdentityCard.IDCardName!==$rootScope.loginInfo.userName) {
//                //                    $rootScope.infoMismatchMsg = '身份证识别失败，请重新上传';
//                //                    $rootScope.infoMismatch();
//                                    control.showPopup("姓名错误请修改", 2000);
//                                    $scope.isClicked = false;
//                                    return;
//                                }
//
//                                if ($scope.checkIdentityCard.IDCardNumber!==$rootScope.loginInfo.idCard) {
//                //                    $rootScope.infoMismatchMsg = '身份证识别失败，请重新上传';
//                //                    $rootScope.infoMismatch();
//                                    control.showPopup("身份证号码错误请修改", 2000);
//
//                                    return;
//                                }
//                }

//                if ($rootScope.autoApplyInfo.IDCardIndate.length < 10 || $rootScope.autoApplyInfo.IDCardIndate.split('-').length < 2) {
//                    $rootScope.OCRFailMsg = '身份证背面照片识别错误，请重新上传';
//                    $rootScope.OCRFail();
//                    $scope.isClicked = false;
//                    return;
//                }
                if($rootScope.autoApplyInfo.IDCardIndate)
//                var expireDate = $rootScope.autoApplyInfo.IDCardIndate.split('-')[1].replace(/\./g, '/');
                var expireDate = $rootScope.autoApplyInfo.IDCardIndate;
                expireDate = expireDate + ' 23:59:59';
                expireDate = new Date(expireDate);
                if (expireDate < new Date()) {
                    $rootScope.OCRFailMsg = '身份证过期，请重新上传';
                    $rootScope.OCRFail();
                    $scope.isClicked = false;
                    return;
                }

                //if ($rootScope.configInfo.faceRecognition == '1') {
                    //navToAuthView();
                //} else {

                    $rootScope.autoApplyInfo.IDCardName=$scope.checkIdentityCard.IDCardName;
                    $rootScope.autoApplyInfo.IDCardNumber=$scope.checkIdentityCard.IDCardNumber;
                    /**
                     * 判断是否收费控制生成业务单流程
                     **/
                 if ($rootScope.certUnderwayInfo.businessCode === 'P012' && !$rootScope.certUnderwayInfo.isFree) {
                           nav.navigate('autoApplyInvoice');
                                return;
                       }
                
                //授权刷脸失败后，材料领证不需要刷脸
                if($rootScope.isNeedAuthFace){
                    $scope.alert_applicant_info=true;
                }else{
                    $rootScope.autoApplyInfo.facePassState = '1';
                    doSaveAutoAuditNetOrderInfo();
                }
                    
                //}
            }
                $scope.closeApplicantInfoAlert=function(){
                    $scope.alert_applicant_info=false;
                }
                $rootScope.autoApplyInfo.facePassState='1';

        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
            
         var liveDetectionNum = 0;
         //开启活体静默检测
         $scope.startLiveDetectionClick = function() {
            $scope.alert_applicant_info = false;
            $scope.acShowAuthConfirm = true;
         };

         var startLiveDetection = function() {
            liveDetectionNum++;
            $scope.alert_applicant_info = false;
            verifyIdentity.startLiveDetection(liveDetectionResult);
        };


        $scope.acShowAuthConfirm = false;
        $scope.acCloseClick = function() {
            $scope.acShowAuthConfirm = false;
        }
        $scope.acIsAgreeApplyAgreement = true;
        $scope.acAgree = function() {
            $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
        }
        $scope.acAgreement = function() {
            var url = window.currentUrl + '/app/api/appfaceagreement';
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }
        $scope.acNext = function() {
            if (!$scope.acIsAgreeApplyAgreement) {
                control.showPopup("请先阅读协议并同意", 2000);
                return;
            }
            $scope.acShowAuthConfirm = false;
            startLiveDetection();
        }







          var photoData='';
         // 验证身份和活体信息是否匹配
         var liveDetectionResult = function(res) {
             $scope.$apply(function() {
                 if (res.base64PhotoData) {
                     photoData = res.base64PhotoData;

                     verifyIdentity.startIdentityAuthenticationAction($rootScope.autoApplyInfo.IDCardName, $rootScope.autoApplyInfo.IDCardNumber, res.base64PhotoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, resultFunc, $rootScope.loginInfo.realNameGrade == "1"?'0':'1');//高实不更新，低实更新0->不更新，1->更新
                     $rootScope.autoApplyInfo.facePassState = '0';
                 } else {
                     authLivingFailEvent();
                     liveDetectionError();
                 }
             });
         };

         var resultFunc = function(data) {
             $scope.$apply(function() {
                 if (data.result == 'fail') {
                     liveDetectionError();
                 }
                 if (data.result == 'success') {
                 if($rootScope.loginInfo.realNameGrade=='0'){
                                        $rootScope.loginInfo.idCard=$rootScope.autoApplyInfo.IDCardNumber;
                                        $rootScope.loginInfo.realNameGrade='1';
                                        $rootScope.loginInfo.userName=$rootScope.autoApplyInfo.IDCardName;
                                        localStorage.setObject('loginInfo', $rootScope.loginInfo);
                                      }

                     $rootScope.autoApplyInfo.facePassState = '0';
                     doSaveAutoAuditNetOrderInfo();
                 }
             });
         }
         var liveDetectionError = function() {
             if (liveDetectionNum < $rootScope.materialFaceMax) {
                 var template = "<div><i class='icon-tips2'></i><h3>核验失败</h3><p> 请确保本人操作或邮寄资料办理业务。 </p></div>";
                 control.showConfirm3(function() {
                     $rootScope.autoApplyInfo.facePassState = '1';
                     doSaveAutoAuditNetOrderInfo();
                 },
                 $scope.startLiveDetection,
                  '重试', '邮寄材料', 'check-information', template);
             } else if (liveDetectionNum ===$rootScope.materialFaceMax) {
                liveDetectionNum=0;
                 var template = "<div><i class='icon-tips2'></i><h3>核验失败</h3><p> 请确保本人操作或邮寄资料办理业务。 </p></div>";
                 control.showConfirm3(function() {
                     $rootScope.autoApplyInfo.facePassState = '1';
                     doSaveAutoAuditNetOrderInfo();
                 },
                 function() {
                     nav.go('home')
                 },
                 '返回首页', '邮寄材料', 'check-information', template);
             }
         }

         $scope.showPhotoRules = function() {
             $scope.isShowPhotoRules = true;
         }

         $scope.hidePhotoRules = function() {
             $scope.isShowPhotoRules = false;
         }

         $scope.navigate = function(state) {
             nav.navigate(state);
         };

        $scope.showPic = false;
        $scope.showPicClick = function() {
            $scope.showPic = true;
        }
        $scope.picClick = function() {
            $scope.showPic = false;
        }
        }]);
})();
