﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('uploadAuthPic', ['$rootScope', '$scope', 'nav', 'control', 'utility', function ($rootScope, $scope, nav, control, utility) {
            $scope.isShowPhotoRules = false;


            $scope.checkPicture = function () {
                var successFunc = function (pic) {
                  $scope.$apply(function () {
                        control.hideLoading();
                        $rootScope.updatePictures.authorizationPic = 'data:image/png;base64,' + pic;
                    });
                };

                var failFunc = function (e) {
                    control.hideLoading();
                };

                control.camera(successFunc, failFunc, false);
            }

            $scope.next = function () {

                if ($rootScope.updatePictures.authorizationPic == '') {
                    control.showPopup('请上传图片', 2000);
                    return;
                }

                nav.navigate('certChange');
            }

            $scope.showPhotoRules = function () {
                $scope.isShowPhotoRules = true;
            }

            $scope.hidePhotoRules = function () {
                $scope.isShowPhotoRules = false;
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();