(function () {
    "use strict"
    angular.module('starter')
        .controller('userNotice', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', '$ionicActionSheet', 'nativeHelper', function ($rootScope, $scope, nav, localStorage, control, $ionicActionSheet, nativeHelper) {

            $rootScope.autoApplyInfo = {
                businessLicensePic: '',
                businessLicenseEntName: '',
                businessLicenseOrgCode: '',
                authorizationPic: '',
                authorizationEntName: '',
                authorizationPerson: '',
                authorizationID: '',
                authorizationTel: '',
                authorizationExpDate: '',
                IDCardFrontPic: '',
                IDCardBackPic: '',
                IDCardName: '',
                IDCardNumber: '',
                IDCardIndate: ''
            };


            $rootScope.cancelBusiness = function () {
                control.showCustomPopup('html/home/autoApply/popupCancelBusiness.html', '', '取消', '继续', 'popup-btn-default', 'popup-btn-light', function () {
                    nav.navigate('reissueOrGetNewCert');
                }, function () {
                    return;
                });
            }


            $rootScope.infoMismatchMsg = '信息不一致，重新上传资料';
            $rootScope.infoMismatch = function () {
                control.showCustomPopup('html/home/autoApply/popupInfoMismatch.html', '', '重传资料', '普通审核通道', 'popup-btn-primary', 'popup-btn-default', function () {
                    return;
                }, function () {
                    $rootScope.isAutoApply = false;
                    nav.navigate('reissueOrGetNewCert');
                });
            }


            $rootScope.OCRFailMsg = '图像识别失败，请重试';
            $rootScope.OCRFail = function () {
                control.showCustomAlert('test', 'html/home/autoApply/popupOCRFail.html', '知道了', 'popup-btn-positive', function () {
                    return;
                });
            }

            $scope.navToTrust = function () {
                $rootScope.entrustTemplateParent = 'userNotice';
                nav.navigate('entrustTemplate');
            }


            $scope.userNotice = {selectAutoOrOrdinary: 1};

            $scope.isAgreeApplyAgreement=false;
            $scope.agree=function(){
            $scope.isAgreeApplyAgreement=!$scope.isAgreeApplyAgreement;
            }

            $rootScope.applyCertInfo={'uniscid':''}
            var confirmOrgCode=function(selectType){
                if ($rootScope.applyCertInfo.uniscid.length!==4) {
                    control.showPopup('请输入统一社会信用代码后4位!', 2000);
                    return;
                }

                if ($rootScope.applyCertInfo.uniscid.toUpperCase() !== $rootScope.certUnderwayInfo.uniscid.substr(-4)) {
                    control.showPopup("信息校验未通过，请确认后再次尝试", 2000);
                    return;
                }
                nav.navigate(selectType)
            }
//            $scope.tipDialog=true;
            $scope.next = function (selectType) {

                if (!$scope.isAgreeApplyAgreement) {
                                    control.showPopup("请阅读并同意协议", 2000);
                                    return;
                                }
                control.showCustomPopup('html/home/popupCheckOrgCode.html', '', '取消', '验证', 'popup-btn-default', 'popup-btn-light', function () { $scope.goBack(); }, function () {
                        confirmOrgCode(selectType);
                    });

//                if($scope.tipDialog){
//                    $scope.tipDialog=false;
//                }
//                switch ($scope.userNotice.selectAutoOrOrdinary) {
//                    case 1:
//                        break;
//                    case 2:
//                        $rootScope.isAutoApply = false;
//                        nav.navigate('certApplyNotice');
//                        break;
//                }

            }

            $scope.navigate = function (state) {
//                $scope.tipDialog=true;
                nav.go(state);
            };
            $scope.goBack = function () {
                nav.goBack();
            };
        }]);
})();
