(function () {
    "use strict"
    angular.module('starter')
        .controller('certExamineMaterial', ['$rootScope', '$scope', '$state', 'nav'
            , 'control', 'nativeHelper', function ($rootScope, $scope, $state, nav, control, nativeHelper) {

//            弃用
                var curRoute = $state.current.name;
                if (curRoute == 'certExamineMaterial') {
                    control.showCustomAlert('test', 'html/home/popupUploadNotice.html', '知道了', 'popup-btn-positive', function () { return; });
                }
                //经办材料导航状态和成功后弹框
                $scope.isSuccess = false;

                $scope.uploadAvatar = function (e) {
                    var successFunc = function (pic) {
                        $scope.$apply(function () {

                            switch (e) {
                                case "idFace":
                                    $rootScope.certExamineMaterial.idFace = pic;
                                    break;
                                case 'idOpposite':
                                    $rootScope.certExamineMaterial.idOpposite = pic;
                                    break;
                                case 'businessLicense':
                                    $rootScope.certExamineMaterial.businessLicense = pic;
                                    break;
                                case 'authorization':
                                    $rootScope.certExamineMaterial.authorization = pic;
                                    break;

                            }
                        });

                    };
                    var failFunc = function () {
                    }
                    control.camera(successFunc, failFunc, true);
                };

                //材料提交
                $scope.submitMaterial = function (isAgree) {

                    if (!isAgree) {
                        control.showPopup("请同意协议", 2000);
                        return;
                    }
                    if ($rootScope.certExamineMaterial.idFace == '' && $rootScope.certExamineMaterial.idOpposite == '' && $rootScope.certExamineMaterial.businessLicense == '' && $rootScope.certExamineMaterial.authorization == '') {
                        control.showPopup("请完善图片信息", 2000);
                        return;
                    }
                    /**
                     * 判断是否收费
                     **/
                    if ($rootScope.certUnderwayInfo.businessCode == 'P012'
                        && !$rootScope.certUnderwayInfo.isFree) {
                        nav.navigate('payCertApplyInvoice');
                        return;
                    }
                    control.showLoading();
                    var params = [$rootScope.certExamineMaterial.idFace, $rootScope.certExamineMaterial.idOpposite,
                    $rootScope.certExamineMaterial.businessLicense, $rootScope.certExamineMaterial.authorization, $rootScope.orderNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        if (result.success) {
                            $scope.$apply(function () {
                                $scope.isSuccess = true;
                            });
                        }
                        if (!result.success) {
                            control.showPopup(result.msg, 3000);
                        }
                    }

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 3000);
                    };

                    nativeHelper.submitMaterialPic({ data: params, success: successFunc, fail: failFunc });

                }


                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();
