﻿(function () {
    "use strict"

    angular.module('starter')
        .controller('businessLicApplyInfo', ['$rootScope', '$scope', '$state', 'nav', 'nativeHelper', 'control', function ($rootScope, $scope, $state, nav, nativeHelper, control) {

        $scope.bApplyInfo={entName:'',entLR:'',idNum:''};
        var uniscid=null;
        var businessLicApply = function (e) {
                $scope.isClicked = false;
                if (cordova.platformId === 'ios' && e.ytErrorcode == 'back') return;

                $scope.$apply(function () {
                    if (e.ytErrorcode == "0") {
                        $state.go('downloadEleBusinessLic', {
                            applyInfo: {
                                'uniscid': uniscid,
                                'unitName': $scope.bApplyInfo.entName, 'fzrName': $scope.bApplyInfo.entLR,
                                'idCard': $scope.bApplyInfo.idNum
                            }
                        });
                    } else {
                        control.showPopup(e.ytErrormsg, 2000);
                    }
                });
            };

            window.broadcaster.addEventListener("businessLicApply", businessLicApply);

            var navToAuthView = function () {
                var params = [
                    $scope.bApplyInfo.entLR,
                    $scope.bApplyInfo.idNum,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.userId,
                    'businessLicApply',
                ];
                var successFunc = function (result) {

                }
                var failFunc = function (result) {
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.navToAuthView({ data: params, success: successFunc, fail: failFunc });
            }

            $scope.checkApplyInfo=function(){
             var timeout = setTimeout(function() {

                 clearTimeout(timeout)

                 if ($scope.bApplyInfo.entName == '') {
                     control.showPopup('企业名称不能为空', 2000);
                     return;
                 }
                 if ($scope.bApplyInfo.entLR == '') {
                     control.showPopup('法定代表人姓名不能为空', 2000);
                     return;
                 }
                 if ($scope.bApplyInfo.idNum == '') {
                     control.showPopup('身份证号码不能为空', 2000);
                     return;
                 }

                 if ($scope.bApplyInfo.idNum.length === 17) {
                     $scope.bApplyInfo.idNum += "X";
                 }
                 control.showLoading();
                 var params = [$rootScope.loginInfo.accountId, $scope.bApplyInfo.entName, $scope.bApplyInfo.entLR, $scope.bApplyInfo.idNum, ];
                 var successFunc = function(result) {
                     control.hideLoading();
                     if (result == null || angular.equals([], result)) {
                         return;
                     }

                     if (result.rslt == 'success') {
                         uniscid = result.uniscid;

                         navToAuthView();
                     } else {
                         control.showPopup(result.errorMsg, 2000);

                     }
                 };

                 var failFunc = function(result) {
                     control.hideLoading();
                     control.showPopup(result.msg, 2000);
                 };

                 nativeHelper.applyEleBusinessLicense({
                     data: params,
                     success: successFunc,
                     fail: failFunc
                 });
             },
             50);
            }
            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
