﻿(function () {
    "use strict"

    angular.module('starter')
        .controller('businessLicDiscern', ['$rootScope', '$scope', '$stateParams', 'nav', 'nativeHelper', 'control', function ($rootScope, $scope, $stateParams, nav, nativeHelper, control) {

            var getElicenseQrCodeResult = function () {
                control.showLoading();
                var params = [
                    $rootScope.curQRCodeInfo.uuid
                ];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals([], result)) { control.showPopup('服务出错啦', 2000); return; }

                    if (result.rslt == 'success') {
                        $scope.fcsElicenseTemp = result.fcsElicenseTemp;

                    } else {
                        control.showPopup(result.errorMsg, 2000);
                        nav.navigate('home');
                    }
                };

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                    nav.navigate('home');
                };
                nativeHelper.getElicenseQrCodeResult({ data: params, success: successFunc, fail: failFunc });
            }
            getElicenseQrCodeResult();
            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
