﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('downloadEleBusinessLic', ['$rootScope', '$scope', '$stateParams', 'nav', 'nativeHelper', 'control','validate',
         function ($rootScope, $scope, $stateParams, nav, nativeHelper, control,validate) {

            var applyInfo = $stateParams.applyInfo;

            $scope.downloadEBusinessLic={password:'',confirmPwd:''};

            $scope.startDownload=function(){
             if (!validate.certPassword($scope.downloadEBusinessLic.password) || !validate.certPassword($scope.downloadEBusinessLic.confirmPwd)) {
                                control.showPopup('请输入6位数字密码', 2000);
                                return;
                            }

                            if ($scope.downloadEBusinessLic.password !== $scope.downloadEBusinessLic.confirmPwd) {
                                control.showPopup('您输入的两次密码不相同', 2000);
                                return;
                            }
                     control.showLoading();

                           var params = [
                           $rootScope.loginInfo.accountId,
                           applyInfo.unitName,
                           applyInfo.fzrName,
                           applyInfo.idCard,
                           $scope.downloadEBusinessLic.password,
                           applyInfo.uniscid,
                           '1'//用户来源 1：联连用户
                           ];
                                      var successFunc = function (result) {
                                          control.hideLoading();
                                          if (result == null || angular.equals([], result)) {
                                              return;
                                          }

                                          if (result.rslt =='success') {
                                            $scope.navigate('eleBusinessLicense');
                                          } else {
                                            control.showPopup(result.errorMsg, 2000);

                                          }
                                      };

                                      var failFunc = function (result) {
                                          control.hideLoading();
                                          control.showPopup(result.msg, 2000);
                                      };

                                      nativeHelper.eleBusinessLicPwd({ data: params, success: successFunc, fail: failFunc });
            }
            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
