﻿(function () {
    "use strict"

    angular.module('starter')
        .controller('viewBusinessLicense', ['$rootScope', '$scope', '$state', 'nav', 'nativeHelper',
         'control', '$interval',function ($rootScope, $scope, $state, nav, nativeHelper, control,$interval) {

            $scope.businessLicense={img:''};
            /**
            * 下载电子营业执照
            * 
            * */
            var downloadEleBusinessLicense = function () {
                control.showLoading();
                var params = [
                    $rootScope.unitName,
                    $rootScope.uniscid
                ];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                      control.showPopup('服务出错啦', 2000);
                       return; }
                    switch (result.rslt) {
                        case 'success':
                            $scope.businessLicense.img = 'data:image/png;base64,' + result.imgBase64;
                            break;
                        case 'fail':
                            control.showPopup(result.errorMsg, 2000);
                            nav.navigate('eleBusinessLicense');
                            break;
                    }
                };

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                    nav.navigate('eleBusinessLicense');
                };

                nativeHelper.downloadBusinessLic({ data: params, success: successFunc, fail: failFunc });

            }
            downloadEleBusinessLicense();

            if('defined' != $rootScope.timer){
            $interval.cancel($rootScope.timer);
            }
            $scope.showBusinessLic = function () {
             $state.go('useBusinessLicense',{
             'imgBase64':$scope.businessLicense.img});
            }
            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();
