(function () {
    "use strict"
    angular.module('starter')
        .controller('reissueOrGetNewCert', ['$rootScope', '$scope', 'nav', 'control',
            'nativeHelper',
            function ($rootScope, $scope, nav, control, nativeHelper) {
                $rootScope.isAutoApply = true;
                $scope.showTimeConfirm = false;

                 //$rootScope.searchResult =   {
                 //       "uniscid" : "91330201MA2AGDHG14",
                 //       "alreadyReceived" : [ {
                 //           "makeUp" : true,
                 //           "corpid" : "3302150000123467",
                 //           "certName" : "测试 _浙江雨琪文化传媒有限公司",
                 //           "category": "省法人数字证书",
                 //           "categoryBh": "010",
                 //       },
                 //        {
                 //           "makeUp" : true,
                 //           "corpid" : "3302150000123467",
                 //           "certName" : "测试 _浙江雨琪文化传媒有限公司",
                 //           "category": "省法人数字证书",
                 //           "categoryBh": "012",
                 //       }],
                 //       "canReceived": [{
                 //            "applyNew": true,
                 //           "category": "省法人数字证书",
                 //           "reason":"不可新领的原因",
                 //           "categoryBh": "010",
                 //            "isFree":false,
                 //           "fee":"200元"

                 //       }, {
                 //           "applyNew": true,
                 //           "category": "省法人数字证书",
                 //           "reason": "不可新领的原因",
                 //           "categoryBh": "011",
                 //           "isFree":true

                 //       }
                 //],
                 //       "entName" : "浙江雨琪文化传媒有限公司"
                 //   }


                $rootScope.isAutoApplyAgreement = false;

                $scope.possess = false;
                $scope.canGet = false;

                $scope.legalPersonCert = [];
                $scope.otherCertTypeList=[];
                var initData=function(){
                    $rootScope.searchResult.alreadyReceived.forEach(function(v){
                            if(v.hasOwnProperty('applyNew')){
                            v.certApplyType='新领'
                            }else if(v.hasOwnProperty('makeUp')){
                             v.certApplyType='补办'
                            }
                               if(v.categoryBh=='010') {
                                   //$scope.legalPersonCert=v;
                                   $scope.legalPersonCert.push(v);
                               }else{
                               $scope.otherCertTypeList.push(v);
                               }
                               });
                    $rootScope.searchResult.canReceived.forEach(function(l){
                        if(l.hasOwnProperty('applyNew')){
                                         l.certApplyType='新领'
                                         }else if(l.hasOwnProperty('makeUp')){
                                          l.certApplyType='补办'
                                         }
                               if(l.categoryBh=='010') {
                              //$scope.legalPersonCert=l;
                              $scope.legalPersonCert.push(l);
                               }else{
                                 $scope.otherCertTypeList.push(l);
                               }
                            })

                    document.getElementById("heightList").style.height = 200 + $scope.otherCertTypeList.length * 200 +'px';
            }

            initData();
                if ($scope.otherCertTypeList.length > 0) {
                    $scope.showMore = true;
                }


                //证书操作类型收缩控制
                $scope.showOtherCert = function () {
                    $scope.showMore = !$scope.showMore;

                }

                /*
                 * 证书新领、补办下一步操作
                 * businessCode: "P012"证书新领 "B03"证书补办
                 * netType业务单类型6:证书新领 8:证书补办 7:子证书新领
                 */
                var onNext = function (item, businessCode, netType) {
                    //封装证书申领进行中所需信息
                    $rootScope.certUnderwayInfo = {
                        entName: $rootScope.searchResult.entName,
                        uniscid: $rootScope.searchResult.uniscid,
                        category: item.category,
                        categoryBh: item.categoryBh,
                        isFree: item.isFree?item.isFree:item.inService,
                        inService: item.inService,
                        corpid: item.corpid,
                        businessCode: businessCode,
                        netType: netType,
                        operator: '',
                        operatorid: '',
                    }
                    $rootScope.certApplyNoticeParent = 'reissueOrGetNewCert';
                    /*
                     *自动审核/人工审核控制
                     *自动审核和人工审核通道合并2019-4-1
                     */
//                    if ($rootScope.isAutoApply && $rootScope.configInfo.faceRecognition
//                        == '1') {
                        nav.navigate('userNotice');
//                    } else {
//                        nav.navigate('certApplyNotice');
//                    }
                }

                /**
                *收费提示
                *B03：已领
                *P012:新领
                */
                var certFeeScale = function (item, type, btnLeft) {
                    var tipContent = '';
                    var btnRight = '';
                    if (type == 'B03') {
                        tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期请先缴纳证书年费后再办理证书相关维护业务。<p>'
                        btnRight = "取消";
                    }

                    control.showConfirm(tipContent,

                        function () {
                        },

                        function () {
                            /*
                            *补办
                            * 业务单类型8:证书补办
                            */
                            if (2 == item.existAnnueeFee) {
                                control.showPopup(item.refuseReason, 3000);
                                return;
                            }
                            if (type == 'B03') {
                                //封装证书年费所需信息
                                $rootScope.certAnnualFeeInfo = {
                                    entName: $rootScope.searchResult.entName,
                                    uniscid: $rootScope.searchResult.uniscid,
                                    category: item.category,
                                    categoryBh: item.categoryBh,
                                    isFree: item.isFree,
                                    corpid: item.corpid,
                                    businessCode: type,
                                    parentPage: 'reissueOrGetNewCert',
                                    operator: '',
                                    operatorid: '',
                                    count: ''
                                }
                                nav.navigate('confirmPayInfo');
                                return;
                            }
                        }, btnLeft, btnRight, 'cusClass');

                }

                var paymentApply = function (item, type, btnLeft) {
                    $rootScope.isFrCert = item.categoryBh == '011' ? true : false;
                    $rootScope.certCharge = item.fee;
                    //     control.showConfirm4('html/home/particularAttention.html', "特别提醒",
                    //     function() {

                    //         /*
                    //                          *新领
                    //                          *
                    //                          * 类目categoryBh为“011”时为子证书（副证书）
                    //                          * 业务单类型6:证书新领 8:证书补办 7:子证书新领
                    //                          */

                    //         if (item.categoryBh == '011') {
                    //             onNext(item, type, "7");
                    //         } else {
                    //             onNext(item, type, "6");
                    //         }
                    //     },

                    //     function() {

                    // },
                    //     "取消", "继续申领", 'cusClassTbtx');

                    let el = document.getElementById("okBtn")
                    el.setAttribute("value", "继续申领(5)");
                    $scope.okFunc = function () {
                        /*
                         *新领
                         *
                         * 类目categoryBh为“011”时为子证书（副证书）
                         * 业务单类型6:证书新领 8:证书补办 7:子证书新领
                         */
                        if (item.categoryBh == '011') {
                            onNext(item, type, "7");
                        } else {
                            onNext(item, type, "6");
                        }
                        $scope.showTimeConfirm = false;
                    }

                    $scope.cancelClick2 = function () {
                        clearInterval(setIntervalByOkBtn);
                        $scope.showTimeConfirm = false;
                    }

                    $scope.isClick = false;

                    el.setAttribute("disabled", true);
                    var okBtnText = 4;
                    function setOKBtn() {
                        if (okBtnText == 0) {
                            clearInterval(setIntervalByOkBtn);
                            el.setAttribute("value", "继续申领");
                            el.removeAttribute("disabled")
                            $scope.$apply(function () {
                                $scope.isClick = true;
                            });
                        } else {
                            el.setAttribute("value", "继续申领(" + okBtnText + ")");
                        }

                        okBtnText--;

                    }

                    var setIntervalByOkBtn = setInterval(() => {
                        setOKBtn();
                    }, 1000);

                    $scope.showTimeConfirm = true;
                }
                $scope.certOperation = function (item) {
                    switch (item.certApplyType) {
                        case '补办':
                            if (!item.makeUp) {//政采云证书
                                  control.showCustom3Popup('知道了','check-information','温馨提示',item.reason);
//                                control.showPopup(item.reason, 2000);
                            } else {
                                  var isHaveTender= $rootScope.searchResult.isHaveTender ? $rootScope.searchResult.isHaveTender:"false"
                                  if(isHaveTender=="true"&&item.isMedium=="true"){
                                    control.showCustom3Popup('知道了','check-information','温馨提示','贵单位近期内有项目正在进行招投标，暂不支持补办业务，请在项目招标结束操作补办业务。');
                                    return;
                                }
                                 if ("true" == item.isMedium) {
                                     control.showConfirm("当前介质证书补办为移动证书后，介质证书将无法继续使用，确定继续补办吗？",
                                    function() {
                                        if (!item.inService) {
                                            certFeeScale(item, 'B03', '续费');
                                        } else {
                                            onNext(item, "B03", "8");
                                        }
                                    },
                                    function() {

                                }, "取消", "继续补办");
                                } else {
                                    if (!item.inService) {
                                        certFeeScale(item, 'B03', '续费');
                                    } else {
                                        onNext(item, "B03", "8");
                                    }
                                }
                            }
                            break;
                        case '新领':
                            if (!item.applyNew) {
                                control.showPopup(item.reason, 2000);
                            } else {
                                if (!item.isFree) {
                                    paymentApply(item, 'P012', '取消');
                                } else {
                                    if (item.categoryBh == '011') {
                                        onNext(item, 'P012', "7");
                                    } else
                                        onNext(item, 'P012', "6");
                                }
                            }
                            break;
                    }
                }
                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);

})();
