(function () {
    "use strict"
    angular.module('starter')
        .controller('showLocalCertList', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'validate', '$filter','$state', 'utility', 'requestWrapper',
            function ($rootScope, $scope, nav, control, nativeHelper, validate, $filter,$state,utility,requestWrapper) {
                //初始化弹框中输入框数据
                $rootScope.localCert = { useCertPwd: '' };
                $scope.searchInfo = { key: '' };
                $scope.showList = false;
                $scope.showLocalCertList = [];
            
                var isEmpty = function(obj){
                    if(typeof obj == "undefined" || obj == null || obj == ""){
                        return true;
                    }else{
                        return false;
                    }
                }

                var getDate=function(date) {
                var time=new Date(date)
                console.log("time  : "+time)
                                time.setDate(time.getDate());
                                var y = time.getFullYear()-1;
                                var m = time.getMonth() + 1;
                                var d = time.getDate();
                                return y + "-" + (m<10?"0"+m:m) + "-" + (d<10?"0"+d:d);
                            }

                var getCertList = function () {
                    var params = [$rootScope.loginInfo.accountId];
                    var successFunc = function (result) {
                        if (result == null || angular.equals({}, result)) {
                            $rootScope.localCertList = [];
                            return;
                        } else {
                            $rootScope.localCertList = result;
                            console.log('cert :'+JSON.stringify($rootScope.localCertList));
                            if ($rootScope.localCertList.length > 0){
                                filterCert()
                            }else{
                                $scope.showList = true;
                            }

                        }
                    }

                    var failFunc = function (e) {

                    };

                    nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
                }

                var filterCert=function(){
                    var certSnList = [];
                    $scope.validLocalCertList=[];
                    if ($rootScope.curQRCodeInfo.type === 'decrypt' || $rootScope.curQRCodeInfo.type === 'mutildec') {
                        var reqData = $rootScope.curQRCodeInfo.reqData.replace(/\\/g,'');
                        var reqDataJson = JSON.parse(reqData);
//                        var needDecodeData=[];
//                        reqDataJson.forEach(function(r){
//                        $rootScope.localCertList.forEach(function(l){
//                            if (l.encSerialNum === r.certsn && needDecodeData.length===0) {
//                                                            certSnList.push(l.serialNum);
//                                                            $scope.validLocalCertList.push(l);
//                                                            needDecodeData.push(r);
//                                                            getCertValidity(certSnList);
//                                                        }
//                            });
//                        })
//                        $rootScope.curQRCodeInfo.reqData=JSON.stringify(needDecodeData);
                        
                        reqDataJson.forEach(function(r){
                            $rootScope.localCertList.forEach(function(l){
                                if (l.encSerialNum === r.certsn) {
                                    certSnList.push(l.serialNum);
                                    $scope.validLocalCertList.push(l);
                                }else{
                                    if(l.uniscid === r.uniscid){
                                        certSnList.push(l.serialNum);
                                        $scope.validLocalCertList.push(l);
                                    }
                                }
                            })
                        })
                        
                        getCertValidity(certSnList);
                    }else if(!isEmpty($rootScope.curQRCodeInfo.certSn) &&($rootScope.curQRCodeInfo.type === 'sign' || $rootScope.curQRCodeInfo.type === 'mutilSign')){
                        $rootScope.localCertList.forEach(function(l){
                            if ($rootScope.curQRCodeInfo.certSn.indexOf(l.serialNum) != -1) {
                                certSnList.push(l.serialNum);
                                $scope.validLocalCertList.push(l);
                            }
                        })
                        getCertValidity(certSnList);
                    }else {
                        $scope.validLocalCertList = angular.copy($rootScope.localCertList);
                        $rootScope.localCertList.forEach(function(v) {
                            certSnList.push(v.serialNum);
                        });
                        getCertValidity(certSnList);
                    }
                }

                let certCount = 10;
                var certSnForValidList = [];
                $scope.allLocalCertList=[];
                // 证书有效性接口验证
                var getCertSnListValidity = function() {
                    if (0 == certSnForValidList.length) {
                        return;
                    }
                    var params = [certSnForValidList[0]];
                    var successFunc = function (result) {
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };

                        if (result.success) {
                            result.value.forEach(function (c) {
                                $scope.validLocalCertList.forEach(function (l) {
                                    if (l.serialNum == c.certSn) {
                                        l.isValid = c.valid;
                                        l.operation = c.operation;
                                        l.canPostpone = c.canPostpone;
                                        l.canModify=c.canModify;
                                        l.reason = c.reason;
                                        if (typeof l.category != 'undefined') {
                                          l.category = c.category;
                                        };
                                        if (typeof l.yearSerEnd != 'undefined') {
                                          l.yearSerEnd = c.yearSerEnd;
                                        };
                                        l.corpid = c.corpid;
                                        //              l.startDate?l.startDate=l.startDate:l.startDate=getDate(l.expiryDate);
                                        $scope.allLocalCertList.push(l);
                                    }
                                });
                            })

                            certSnForValidList.splice(0, 1);
                            if (0 != certSnForValidList.length) {
                                getCertSnListValidity();
                            } else {
                                $scope.showList = true;
                                control.hideLoading();
                            }
                            $scope.showLocalCertList = angular.copy($scope.allLocalCertList);
                        }
                        else {
                            control.showPopup(result.msg, 2000);
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.getCertValidity({ data: params, success: successFunc, fail: failFunc });
                }

                //过滤本地证书
                var getCertValidity = function (certSnList) {
                    if(certSnList.length === 0){
                        $scope.showList = true;
                        return;
                    }
                    control.showLoading();
                    // 证书分组
                    var tmpSubArr = [];
                    for (let index = 0; index < certSnList.length; index++) {
                        const element = certSnList[index];
                        tmpSubArr.push(element);
                        if (0 == (index+1)%certCount || index == certSnList.length-1) {
                            certSnForValidList.push(tmpSubArr);
                            tmpSubArr = [];
                        }
                    }
                    getCertSnListValidity();
                };


                //  getCertList();
                // 校验二维码是否可用
                var checkAppCanScanQrcode = function () {
                    control.showLoading();
                    var time = utility.getCurrentTime();
                    var hashdata = utility.sm3HashBase64($rootScope.appid + time + $rootScope.secret);
                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "app": "ezt",
                        "businessAppId": $rootScope.curQRCodeInfo.businessAppId
                    };
                    console.log("checkAppCanScanQrcode " + JSON.stringify(params));
                    requestWrapper.checkAppCanScanQrcode({data: params, refresh: true})
                        .then(function (result) {
                            control.hideLoading();
                            console.log("checkAppCanScanQrcode res:"+ JSON.stringify(result));
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if ("success" == result.rslt) {
                                if (true == result.data.isAuth) {
                                    getCertList();
                                } else {
                                    control.showAlert1(result.data.falseMsg, function() {
                                        nav.navigate('home');
                                    });
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }

                        })
                        .catch(function (e) {
                            control.hideLoading();
                            control.showPopup('网络请求失败：' + e.status, 3000);
                        });

                }
                checkAppCanScanQrcode();
            
                var showUploadMsg = function (e) {
                    control.showPopup(e.msg, 2000);
                }

                window.broadcaster.addEventListener("showUploadMsg", showUploadMsg);

                var signEvent = function() {
                    var eventCounter = new Object();
                    eventCounter.page = "扫码签名";
                    MobclickAgent.onEventWithParameters("signEvent", eventCounter);
                }
            
                var signUploadEvent = function() {
                    var eventCounter = new Object();
                    eventCounter.page = "签名上传";
                    MobclickAgent.onEventWithParameters("signUploadEvent", eventCounter);
                }
            
                var confirmPwd = function (curCert) {
                    if (!validate.certPassword($rootScope.localCert.useCertPwd)) {
                        control.showPopup('请输入6位数字密码', 2000);
                        return;
                    }

                    if ($rootScope.localCert.useCertPwd !== curCert.password) {
                        control.showPopup("证书密码不正确！", 2000);
                        return;
                    }

                    control.showLoading();
                    signEvent();//监听扫码签名
                    
                    //param1:二维码扫描结果
                    //param2:选中证书对应的容器
                    //param3:证书base64,与对应容器里到处的校验下是否一致
                    //param4:用户输入的证书使用密码（容器PIN码）
                    var params = [$rootScope.curQRCodeInfo, curCert.containerName, curCert.certContent, $rootScope.localCert.useCertPwd,curCert.SDKVersion, $rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, curCert.serialNum, curCert.encSerialNum,$rootScope.loginInfo.accountId,$rootScope.loginInfo.mobile,curCert.uniscid];
                    console.log(params)
                    var successFunc = function (result) {
                        $rootScope.localCert = { useCertPwd: '' };
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        
                        signUploadEvent();//上传监听

                        if (result.rslt == 'success') {
                            if($rootScope.curQRCodeInfo.versions=="3"&&$rootScope.curQRCodeInfo.openSign=="1"){
                                $state.go('signCompleted',{cert:curCert});
                                return;
                            }else{
                                control.showPopup('扫码操作成功', 2000);
                            }
                        }
                        else {
                            if(result.errorMsg.includes("签名验证失败")){
                                control.showPopup(result.errorMsg + "，请重新下载证书后重试！", 2000);
                            }else{
                                control.showPopup(result.errorMsg, 2000);
                            }
                        }
                        
                         nav.navigate('home');
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        if(result.errorMsg.includes("签名验证失败")){
                            control.showPopup(result.errorMsg+"请重新下载证书后重试！", 2000);
                            requestWrapper.sendMesToDingTalk("密码模块错误","扫码上传",result.alarmMsg+"请重新下载证书后重试！")
                        }else{
                            control.showPopup(result.errorMsg, 2000);
                            requestWrapper.sendMesToDingTalk("密码模块错误","扫码上传",result.alarmMsg)
                        }
                    };

                    setTimeout(function () {
                        nativeHelper.uploadinfo({ data: params, success: successFunc, fail: failFunc });
                    }, 1000);
                }


                $scope.selectCert = function (curCert) {
                    if (curCert.SDKVersion !== "V2") {
                        control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                        function() {
                            $scope.navigate("businessManage");
                            return;
                        },
                        function() {},
                        "取消", "去业务管理", 'cusClassTbtx');
                        return;
                    }
                    
                    if($rootScope.curQRCodeInfo.type != 'decrypt' && !curCert.isValid){
                        control.showPopup('请选择有效证书', 2000);
                        return;
                    }
                    
                    //判断二维码的证书序列号是否与选中的匹配
                    if ($rootScope.curQRCodeInfo.certSn && $rootScope.curQRCodeInfo.certSn !== '' && !$rootScope.curQRCodeInfo.certSn.indexOf(curCert.serialNum) == -1) {
                        control.showPopup('请选择正确的证书', 2000);
                        return;
                    }
                    
                    // if(curCert.sourceClient === 'ZCY' && $rootScope.curQRCodeInfo.businessAppId != 'zcy-ztb'){
                    //     control.showPopup('该证书只能用于政采云相关应用', 2000);
                    //     return;
                    // }
                    
                    // if(curCert.sourceClient != 'ZCY' && $rootScope.curQRCodeInfo.businessAppId === 'zcy-ztb' && curCert.certType != '省法人数字证书'){
                    //     control.showPopup('该证书不可用于政采云相关应用', 2000);
                    //     return;
                    // }


                    let curQRCodeInfo = $rootScope.curQRCodeInfo;
                    console.log('curQRCodeInfo -- ' + JSON.stringify(curQRCodeInfo));
                    // if ('3' == curQRCodeInfo.versions) {
                        judgeCertAllowUseRange(curCert);
                    // } else {
                    //     $rootScope.localCert = { useCertPwd: '' };
                    //     control.showCustomPopup('html/home/popupUseCert.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () { return; }, function () {
                    //         confirmPwd(curCert);
                    //     });
                    // }

                }

                // 判断证书在某应用是否能使用
                var judgeCertAllowUseRange = function (curCert) {
                    control.showLoading();

                    /**
                     * appid         签章平台分配给招标平台的id
                     * time          时间戳，当前时间年月日时分秒 20091010121212
                     * hashdata      (appid+time+secret)将资源接入代码、发送时间、业务密钥按顺序连接并进行md5加密。
                     * certSn        签名证书序号
                     * businessAppId 二维码应用编号
                     */
                    var params = [curCert.serialNum, $rootScope.curQRCodeInfo];
                    
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result.success) {
                            $rootScope.localCert = { useCertPwd: '' };
                            control.showCustomPopup('html/home/popupUseCert.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () { return; }, function () {
                                confirmPwd(curCert);
                            });
                        } else {
                            control.showPopup(result.msg, 2000);
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    setTimeout(function () {
                        nativeHelper.certAllowUseRange({ data: params, success: successFunc, fail: failFunc });
                    }, 1000);
                }




                /**
                * 搜索证书
                */
                $scope.searchCert = function () {
                    if ($scope.searchInfo.key == '') {
                        $scope.showLocalCertList = $scope.allLocalCertList;
                        return;
                    }
                    $scope.showLocalCertList = $filter('filter')($scope.allLocalCertList, $scope.searchInfo.key);
                    //关闭软键盘
                    cordova.plugins.Keyboard.close();

                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();
