(function () {
    "use strict"
    angular.module('starter')
        .controller('messageCenter', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', '$state', 'nativeHelper', function ($rootScope, $scope, nav, localStorage, control, $state, nativeHelper) {

            $scope.msgType="all";
            var pageSize=10;
            $scope.can_loadmore = true;
            $scope.isloadmore = false;

            //获取消息列表
            var getNotificationMsgList = function (pageSize,type) {

                control.showLoading();
                var params = [$rootScope.loginInfo.mobile,1,pageSize,type];
                var successFunc = function (result) {
                    control.hideLoading();
                    $scope.can_loadmore = true;
                     $scope.isloadmore = false;
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.rslt=='success') {
                        $scope.$apply(function () {
//                        if(pageSize==1){
//                            $scope.cacheMsgListRecord=[];
                            $scope.cacheMsgListRecord=result.data;
                            return;
//                        }else{
//                        if(result.data.topmsglist!=null){
//                        if(result.data.topmsglist.length>0)
//                                                $scope.cacheMsgListRecord.topmsglist.push(result.data.topmsglist);
//
//                                                console.log("topmsglist"+$scope.cacheMsgListRecord.topmsglist.length);
//                        }
//
//
//                        result.data.msglist.length>0?$scope.cacheMsgListRecord.msglist.push(result.data.msglist):'';
//
//                        console.log("msglist"+$scope.cacheMsgListRecord.msglist.length);
//                        }

                        });
                    }
                    if (result.rslt=='fail') {
                        control.showPopup(result.errormsg, 2000);
                    }
                }

                var failFunc = function (error) {
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                };

                nativeHelper.getNotificationMsgList({ data: params, success: successFunc, fail: failFunc });
            };
            //默认获取所有消息
            getNotificationMsgList(pageSize,$scope.msgType);

            //下拉刷新
            $scope.doRefresh=function(){
                pageSize=10;
                getNotificationMsgList(pageSize,$scope.msgType);
                $scope.$broadcast('scroll.refreshComplete');
            }
            //上拉加载更多
            $scope.loadMore = function () {
            console.log("$scope.cacheMsgListRecord.pages :"+pageSize);
                    if ($scope.cacheMsgListRecord.total > pageSize) {
                        pageSize=10+pageSize;
                        control.showLoading();
                        getNotificationMsgList(pageSize,$scope.msgType);
//                        $scope.can_loadmore = false;
                    } else {
                        $scope.isloadmore = true;
                    }
                    $scope.can_loadmore = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                };
            //获取消息根据类型
            $scope.getMsgList=function(type){
                $scope.msgType=type;
                pageSize=10;
                getNotificationMsgList(pageSize,type);
            }
            //根据通知消息item的type处理相应的详情处理逻辑
            var viewDetailsEvent=function(item){
            switch(item.type){
                case 'text':
                $state.go('messageDetails',{'msgDetail':item});
            return;
            case 'url':
            if(cordova.platformId==='android'){
            var operation = 'location=no,toolbar=no,toolbarposition=top,toolbarType=title,certList='+JSON.stringify($rootScope.localCertList);
            }else
                var operation = 'location=no,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
//                                cordova.InAppBrowser.open(item.details, '_system', operation);
                                cordova.InAppBrowser.open(item.details, '_blank', operation);
                        return;
                         case 'urlparam':
                        $state.go('applyCertComplete',{'msgDetail':item});
                        return;

                        case 'activity':
                        if(item.details=='1'||item.details=='2'){
                            nav.go('authorizationRecord');
                        }

                        return;

            }

            }
            //修改本地缓存消息是否已读状态
            var changeMsgState=function(item){
                      $scope.cacheMsgListRecord.msglist.forEach(function(v) {
                                if (v.msg_id==item.msg_id) {
                                    v.status = '已读'
                                    if($scope.msgType=='unread'){
                                    var index =$scope.cacheMsgListRecord.msglist.indexOf(v);
                                     $scope.cacheMsgListRecord.msglist.splice(index,1)
                                    }

                                }
                            });
                            $scope.cacheMsgListRecord.topmsglist.forEach(function(v) {
                                if (v.msg_id==item.msg_id) {
                                    v.status = '已读'
                                     if($scope.msgType=='unread'){
                                     var index =$scope.cacheMsgListRecord.topmsglist.indexOf(v);
                                      $scope.cacheMsgListRecord.topmsglist.splice(index,1)
                                                                        }

                                }
                            });
            }
            //设置消息状态
            var setNotificationMsgState = function (item) {

                control.showLoading();
                if(item.sendtype=='broadcast'){

                }
                var params = [item.sendtype,$rootScope.loginInfo.mobile,item.msg_id];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.rslt=='success') {
                        $scope.$apply(function () {
                            changeMsgState(item);
//                            viewDetailsEvent(item);
                        });
                    }
                    if (result.rslt=='fail') {
                        control.showPopup(result.errormsg, 2000);
                    }
                }

                var failFunc = function (error) {
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                };

                nativeHelper.notificationMsgState({ data: params, success: successFunc, fail: failFunc });
            };

            //查看详情
            $scope.viewDetails=function(item){
                viewDetailsEvent(item);
                if(item.status=='未读'){
                    setNotificationMsgState(item);
                }
            }

            //删除本地缓存数据
            var deleteItem=function(item){
            var index=$scope.cacheMsgListRecord.msglist.indexOf(item);
                         $scope.cacheMsgListRecord.msglist.forEach(function(v) {
                                                        if (v.msg_id==item.msg_id) {
                                                            $scope.cacheMsgListRecord.msglist.splice(index,1);
                                                        }
                                                    });
            }
            //删除服务器记录
            $scope.deleteMsg=function(item){
                    control.showLoading();
                             var params = [item.sendtype,$rootScope.loginInfo.mobile,item.msg_id];
                             var successFunc = function (result) {
                                 control.hideLoading();
                                 if (result == null || angular.equals({}, result)) {
                                     control.showPopup('服务出错啦', 2000);
                                     return;
                                 }
                                 if (result.rslt=='success') {
                                     $scope.$apply(function () {
                                        control.showPopup('删除成功!', 2000);
                                        deleteItem(item);
                                     });
                                 }
                                 if (result.rslt=='fail') {
                                    control.showPopup(result.errormsg, 2000);
                                    getNotificationMsgList(10,$scope.msgType);
                                 }
                             }

                             var failFunc = function (error) {
                                 control.hideLoading();
                                 control.showPopup(error.msg, 2000);
                                 getNotificationMsgList(10,$scope.msgType);
                             };

                             nativeHelper.deleteMsg({ data: params, success: successFunc, fail: failFunc });
            }

            $scope.navigate = function (state) {
            if(state=='home'){
                $state.go('home',{pagePath:'messageCenter'});
                return;
            }
                nav.navigate(state);
            };
        }]);
})();
