﻿(function () {
    angular.module('starter')
    .directive('htmlInside', [function () {
        return {
            restrict: 'EA',
            template: '<div></div>',
            replace: true,
            scope: {
                content: '&',
            },
            link: function (scope, element, attrs) {
                element.html(scope.content());

                scope.$watch('content()', function (newVal) { element.html(newVal); });
            }
        };
    }]);
})();