﻿(function () {
    angular.module('starter')
    .directive('markedInput', [function () {
        return {
            restrict: 'E',
            templateUrl: 'html/directives/markedInput.html',
            replace: true,
            scope: {
                success: '=',
                error: '=',
                warning: '=',
                showClear: '=',
                value: '=',
                delay: '&',
                placeholder: '@' ,
                disable: '=',
                blurCustom: '&',
                type: '@'
            },
            link: function (scope, element, attrs) {
                scope.isFocus = function () {
                    scope.showClear = true;
                };
                scope.isBlur = function () {
                    scope.showClear = false;
                    scope.blurCustom()
                };
            }
        };
    }]);
})();