(function () {
    angular.module('starter')
    .directive('shareAlert',
    ['nativeHelper','control','$ionicPlatform','$location','$ionicHistory',function (nativeHelper,control,$ionicPlatform,$location,$ionicHistory) {
        return {
            restrict: 'E',
            templateUrl: 'html/directives/shareAlert.html',
            // replace: true,
            scope: {
                showShare: '=',
                linkContent:'=',
                cancel:'&',
            },

             link:function(scope, element, attrs) {
//              console.log(" 2342342"+scope.showShare);
                scope.cancelShare=function(){
                    scope.cancel();
                 }
                //0：QQ，1：复制，2：微信，3：短信
                scope.share = function(shareMode) {
                    scope.cancel();
                    var successFunc = function(result) {
                        var eventCounter = new Object();
                        eventCounter.page = "发送审批信息";
                        MobclickAgent.onEventWithParameters("shareEvent", eventCounter);
                    
                        if (shareMode == 1){
                            control.showPopup('复制成功', 2000);
                        }
                    }

                    var failFunc = function(error) {
        //                console.log(error);
                        control.showPopup('分享失败,请选择复制', 2000);
                    };

                    nativeHelper.socialAgent({
                        data: [scope.linkContent,shareMode],
                        success: successFunc,
                        fail: failFunc
                    });
                }
            }
        };
    }]);
})();
