﻿(function () {
    "use strict"

    angular.module('starter')
    .factory('const', [function () {
        return {
            events: {
                siteMsg: 'siteMsg',
                cancelMsg: 'cancelMsg'
            },
            datetimeFormat: {
                date: {
                    en: 'M/D/YYYY',
                    zh: 'YYYY/M/D',
                    ja: 'M/D/YYYY'
                },
                monthYear: {
                    en: 'MMM YYYY',
                    zh: 'YYYY MMM',
                    ja: 'MMM YYYY'
                },
                month: {
                    en: 'MMM',
                    zh: 'MMM',
                    ja: 'MMM'
                },
                monthLong: {
                    en: 'MMMM',
                    zh: 'MMMM',
                    ja: 'MMMM'
                },
                datetime: {
                    en: 'M/D/YYYY hh:mm:ss A',
                    zh: 'YYYY/M/D HH:mm:ss',
                    ja: 'M/D/YYYY hh:mm:ss A'
                }
            },
            msgType: {
                error: 'error',
                info: 'info',
                warn: 'warn',
                success: 'success'
            }
        };
    }]);
})();