(function () {
    //"use strict"

    angular.module('starter')
        .factory('nativeHelper', [function () {
            var nativeCaller = function (method, options) {
                return Cordova.exec(options.success, options.fail, "CertPlugin", method, options.data);
            };
            var authCaller = function (method, options) {
                return Cordova.exec(options.success, options.fail, "TXAuthPlugin", method, options.data);
            };
            var eLicense = function (method, options) {
                return Cordova.exec(options.success, options.fail, "ELicensePlugin", method, options.data);
            };
             var authorization = function (method, options) {
                return Cordova.exec(options.success, options.fail, "AuthorizationPlugin", method, options.data);
            };
             var notificationMsg = function (method, options) {
                return Cordova.exec(options.success, options.fail, "NotificationMsgPlugin", method, options.data);
            };

            // 获取native的基本数据
            var getBaseConfig = function (options) { nativeCaller("getBaseConfig", options); };

            //加、解密
            var getEncryptAndDecryptStr = function (options) { nativeCaller("getEncryptAndDecryptStr", options); };

            //检查更新
            var checkUpdate = function (options) { nativeCaller("checkUpdate", options); };

            //用户登录
            var signIn = function (options) { nativeCaller("signIn", options); };

            //修改用户密码
            var modifyPassword = function (options) { nativeCaller("modifyPassword", options); };

            //获取验证码
            var getMesAuthCode = function (options) { nativeCaller("getMesAuthCode", options); };

            //用户注册
            var signUp = function (options) { nativeCaller("signUp", options); };
            
            // 安卓 退出
            var signOut = function (options) { nativeCaller("signOut", options); };

            //扫一扫
            var navToScanView = function (options) { nativeCaller("navToScanView", options); };
                                  
            //IOS系统分享
            var navToShareView = function (options) { nativeCaller("navToShareView", options); };

            //主体查询搜索
            var getSubjectQuerySearch = function (options) { nativeCaller("getSubjectQuerySearch", options); };

            //业务列表
            var getBusinessInfoList = function (options) { nativeCaller("getBusinessInfoList", options); };

            //生成业务单
            var getSaveNetOrderInfo = function (options) { nativeCaller("getSaveNetOrderInfo", options); };

            //业务单材料提交
            var submitMaterialPic = function (options) { nativeCaller("submitMaterialPic", options); };

            //检查是否存在重复业务单
            var judgeRepeatNetOrder = function (options) { nativeCaller("judgeRepeatNetOrder", options); };

            //修改业务单
            var doUpdateNetOrderInfo = function (options) { nativeCaller("doUpdateNetOrderInfo", options); };

            //下载证书
            var downloadCert = function (options) { nativeCaller("downloadCert", options); };

            //二维码结果上传
            var uploadinfo = function (options) { nativeCaller("uploadinfo", options); };

            //证书能否在某应用使用（根据证书序号、二维码应用编号）
            var certAllowUseRange = function (options) { nativeCaller("certAllowUseRange", options); }

             //获取会签信息
            var getSignList = function (options) { nativeCaller("getSignList", options); };

             //中止会签
            var invalidationQrCode = function (options) { nativeCaller("invalidationQrCode", options); };

            //打开普华SDK应用
            var openApplication = function (options) { nativeCaller("openApplication", options); };

            //修改证书密码
            var changeCertPwd = function (options) { nativeCaller("changeCertPwd", options); };

            //重置证书密码
            var resetCertPwd = function (options) { nativeCaller("resetCertPwd", options); };

            //删除证书
            var deleteCert = function (options) { nativeCaller("deleteCert", options); };

            //证书是否有效
            var getCertValidity = function (options) { nativeCaller("getCertValidity", options); };

            //启用证书
            var doStartCert = function (options) { nativeCaller("doStartCert", options); };

            //加载动画
            var showLoading = function (options) { nativeCaller("showLoading", options); };
            //关闭动画
            var closeLoading = function (options) { nativeCaller("closeLoading", options); };

            //证书变更-继续办理业务，更新资料；
            var reviseNetOrderInfo = function (options) { nativeCaller("reviseNetOrderInfo", options); };

            //证书变更、延期
            var certChangeInfo = function (options) { nativeCaller("certChangeInfo", options); };

            //根据证书查询企业信息
            var doGetEntInfo = function (options) { nativeCaller("doGetEntInfo", options); };

            //OCR识别身份证
            var checkIdentityCard = function (options) { nativeCaller("checkIdentityCard", options); };

            //APP配置项查询接口
            var getConfigInfo = function (options) { nativeCaller("getConfigInfo", options); };

            //资料更新获取图片
            var getUpdateMaterialPic = function (options) { nativeCaller("getUpdateMaterialPic", options); };

            //自动审核新流程生成业务单接口
            var doSaveAutoAuditNetOrderInfo = function (options) { nativeCaller("doSaveAutoAuditNetOrderInfo", options); };

            //存储证书列表
            var setLocalCertList = function (options) { nativeCaller("setLocalCertList", options); };

            //获取证书列表
            var getLocalCertList = function (options) { nativeCaller("getLocalCertList", options); };

            //根据证书序列号读取本地证书
            var getSpecifiedCert = function (options) { nativeCaller("getSpecifiedCert", options)};
            
            //实人认证
            var navToAuthView = function (options) { authCaller("navToAuthView", options); };

            //付款新领生成业务单
            var doSaveNetOrderInfoWithInvoice = function (options) { nativeCaller("doSaveNetOrderInfoWithInvoice", options); };

            //生成签名业务单
            var paymentOrder = function (options) { nativeCaller("paymentOrder", options); };

            //生成年费业务单
            var doSaveAnnualFeeNetOrderInfo = function (options) { nativeCaller("doSaveAnnualFeeNetOrderInfo", options); };

            //自动审核新流程生成业务单接口
            var doSaveAutoAuditNetOrderInfoWithInvoice = function (options) { nativeCaller("doSaveAutoAuditNetOrderInfoWithInvoice", options); };

            //查询有效授权领证信息和有效网点领证信息接口
            var doGetPermitInfo = function (options) { nativeCaller("doGetPermitInfo", options); };

            //网点资料领证生成业务单接口
            var doSaveOfflineDataNetOrderInfo = function (options) { nativeCaller("doSaveOfflineDataNetOrderInfo", options); };

            //检查证书年报状态
            var getYearReportStatus = function (options) { nativeCaller("getYearReportStatus", options); };

            //检查授权记录下载证书是否收费
            var getFeeInfo = function (options) { nativeCaller("getFeeInfo", options); };

            //存储证书
//            var storeCert = function (options) { nativeCaller("storeCert", options); };
//
//            //读取存储证书
            var loadLocalCertListData = function (options) { nativeCaller("loadLocalCertListData", options); };
              
            //强制横、竖屏
            var setOrientation=function(options){nativeCaller("setOrientation", options);};

            //获取电子营业执照企业列表信息
            var getEleBusinessLicenseList = function (options) { eLicense("getEleBusinessLicenseList", options); };

            //电子营业执照申请信息
            var applyEleBusinessLicense = function (options) { eLicense("applyEleBusinessLicense", options); };

            //电子营业执照密码
            var eleBusinessLicPwd = function (options) { eLicense("eleBusinessLicPwd", options); };

            //下载电子营业执照
            var downloadBusinessLic = function (options) { eLicense("downloadBusinessLic", options); };

            //获取使用电子营业执照二维码
            var getBusinessLicQRCode = function (options) { eLicense("getBusinessLicQRCode", options); };

            //4.6   获取执照识别结果接口
            var getElicenseQrCodeResult = function (options) { eLicense("getElicenseQrCodeResult", options); };

            //证书授权申领--获取授权信息
            var getAuthorizationComfirmInfo = function (options) { authorization("getAuthorizationComfirmInfo", options); };

            //证书授权申领--生成业务单
            var createOrders = function (options) { authorization("createOrders", options); };

            //授权申领--查询企业
            var searchAuthorizeEnt=function(options){authorization("searchAuthorizeEnt", options);};

            //授权申领--检查连联账号是否实名
            var checkLinkAccount=function(options){authorization("checkLinkAccount", options);};

            //授权申领--核验经办人信息
            var checkClaimantInfo=function(options){authorization("checkClaimantInfo", options);};

            //授权申领--活体人脸识别
            var liveDetection=function(options){authorization("liveDetection", options);};

              //授权申领--申请授权证书信息
            var applyAuthorize=function(options){authorization("applyAuthorize", options);};

             //授权申领--身份验证
            var identityAuthentication=function(options){authorization("identityAuthentication", options);};

            //授权申领--获取用户人脸图片
            var getUserFace=function(options){authorization("getUserFace", options);};

            //授权申领--生成业务单
            var doSaveAuthNetOrderInfo=function(options){authorization("doSaveAuthNetOrderInfo", options);};

            //授权申领--付费业务单
            var doSaveAuthNetOrderInfoWithInvoice=function(options){authorization("doSaveAuthNetOrderInfoWithInvoice", options);};

            //授权申领--启用授权下载的证书
            var doStartCertAndSaveEvidence=function(options){authorization("doStartCertAndSaveEvidence", options);};

            //复制
            var socialAgent=function(options){authorization("socialAgent", options);};

            //获取消息列表
            var getNotificationMsgList=function(options){notificationMsg("getNotificationMsgList", options);};

            //修改消息状态
            var notificationMsgState=function(options){notificationMsg("notificationMsgState", options);};

            //删除消息
            var deleteMsg=function(options){notificationMsg("deleteMsg", options);};

            //首页消息图标--检查是否存在未读消息
            var checkUnreadNotification=function(options){notificationMsg("checkUnreadNotification", options);};

            //拒绝授权
            var refuseAuthorization=function(options){authorization("refuseAuthorization", options);};

            //同意授权-提交签名
            var checkPass=function(options){authorization("checkPass", options);};

            //同意授权-查询是否存在有效管理员
            var existValidAdmin=function(options){authorization("existValidAdmin", options);};

            //申请授权--设置管理员
            var setAdmin=function(options){authorization("setAdmin", options);};

            //申请授权--获取身份标签
            var getIdentityLabel=function(options){authorization("getIdentityLabel", options);};

            //授权申请--法人授权--经办人列表
            var getAgenterList=function(options){authorization("getAgenterList", options);};

            //授权申请--添加经办人
            var addAgenter=function(options){authorization("addAgenter", options);};

            //授权申请--法人授权经办人
            var addAuthInfoByFr=function(options){authorization("addAuthInfoByFr", options);};

            //授权申请--判断经办人身份类型
            var checkIdentity=function(options){authorization("checkIdentity", options);};

            //授权申请--更新扩展字段
            var updateExtendData=function(options){authorization("updateExtendData", options);};


            //业务管理--撤销业务单
            var doCancelNetOrder=function(options){nativeCaller("doCancelNetOrder", options);};


            return {
                checkUpdate: checkUpdate,
                getBaseConfig: getBaseConfig,
                getEncryptAndDecryptStr: getEncryptAndDecryptStr,
                signIn: signIn,
                modifyPassword: modifyPassword,
                signUp: signUp,
                signOut: signOut,
                getMesAuthCode: getMesAuthCode,
                navToScanView: navToScanView,
                getSubjectQuerySearch: getSubjectQuerySearch,
                getBusinessInfoList: getBusinessInfoList,
                getSaveNetOrderInfo: getSaveNetOrderInfo,
                submitMaterialPic: submitMaterialPic,
                judgeRepeatNetOrder: judgeRepeatNetOrder,
                doUpdateNetOrderInfo: doUpdateNetOrderInfo,
                downloadCert: downloadCert,
                uploadinfo: uploadinfo,
                certAllowUseRange: certAllowUseRange,
                getSignList: getSignList,
                openApplication: openApplication,
                changeCertPwd: changeCertPwd,
                resetCertPwd: resetCertPwd,
                deleteCert: deleteCert,
                getCertValidity: getCertValidity,
                doStartCert: doStartCert,
                showLoading: showLoading,
                closeLoading: closeLoading,
                reviseNetOrderInfo: reviseNetOrderInfo,
                certChangeInfo: certChangeInfo,
                doGetEntInfo: doGetEntInfo,
                checkIdentityCard: checkIdentityCard,
                getConfigInfo: getConfigInfo,
                getUpdateMaterialPic: getUpdateMaterialPic,
                doSaveAutoAuditNetOrderInfo: doSaveAutoAuditNetOrderInfo,
                setLocalCertList: setLocalCertList,
                getLocalCertList: getLocalCertList,
                getSpecifiedCert: getSpecifiedCert,
                navToAuthView: navToAuthView,
                doSaveNetOrderInfoWithInvoice: doSaveNetOrderInfoWithInvoice,
                paymentOrder: paymentOrder,
                doSaveAnnualFeeNetOrderInfo: doSaveAnnualFeeNetOrderInfo,
                doSaveAutoAuditNetOrderInfoWithInvoice: doSaveAutoAuditNetOrderInfoWithInvoice,
                getEleBusinessLicenseList: getEleBusinessLicenseList,
                applyEleBusinessLicense: applyEleBusinessLicense,
                eleBusinessLicPwd: eleBusinessLicPwd,
                downloadBusinessLic: downloadBusinessLic,
                getBusinessLicQRCode: getBusinessLicQRCode,
                getElicenseQrCodeResult: getElicenseQrCodeResult,
                getAuthorizationComfirmInfo:getAuthorizationComfirmInfo,
                createOrders:createOrders,
                searchAuthorizeEnt:searchAuthorizeEnt,
                checkClaimantInfo:checkClaimantInfo,
                liveDetection:liveDetection,
                identityAuthentication:identityAuthentication,
                getUserFace:getUserFace,
                checkLinkAccount:checkLinkAccount,
                applyAuthorize:applyAuthorize,
                doSaveAuthNetOrderInfo:doSaveAuthNetOrderInfo,
                doSaveAuthNetOrderInfoWithInvoice:doSaveAuthNetOrderInfoWithInvoice,
                authorization:authorization,
                doStartCertAndSaveEvidence:doStartCertAndSaveEvidence,
                socialAgent:socialAgent,
                getNotificationMsgList:getNotificationMsgList,
                notificationMsgState:notificationMsgState,
                deleteMsg:deleteMsg,
                refuseAuthorization:refuseAuthorization,
                checkPass:checkPass,
                doGetPermitInfo:doGetPermitInfo,
                doSaveOfflineDataNetOrderInfo:doSaveOfflineDataNetOrderInfo,
                getYearReportStatus:getYearReportStatus,
                existValidAdmin:existValidAdmin,
                getIdentityLabel:getIdentityLabel,
                getAgenterList:getAgenterList,
                addAgenter:addAgenter,
                checkIdentity:checkIdentity,
                setAdmin:setAdmin,
                checkUnreadNotification:checkUnreadNotification,
                addAuthInfoByFr:addAuthInfoByFr,
                getFeeInfo:getFeeInfo,
//                storeCert:storeCert,
//                getCertList:getCertList,
                navToShareView:navToShareView,
                setOrientation:setOrientation,
                doCancelNetOrder:doCancelNetOrder,
                updateExtendData:updateExtendData,
                loadLocalCertListData:loadLocalCertListData,
                invalidationQrCode:invalidationQrCode,
            };
        }]);
})();
