(function () {
    "use strict"

    angular.module('starter')
        .factory('url', ['$rootScope' , function ($rootScope) {
            var serverUrl = $rootScope.urlConfig.serverUrl;
            var cloudCertUrl = $rootScope.urlConfig.cloudCertUrl;
            var doDecDataUrl = $rootScope.urlConfig.doDecDataUrl;
            var authCenterUrl = $rootScope.urlConfig.authCenterUrl;
            var scanUrl = $rootScope.urlConfig.scanUrl;
            var OCRUrl = $rootScope.urlConfig.OCRUrl;
            var CTIDAuthUrl = $rootScope.urlConfig.CTIDAuthUrl;
            var msgCenterUrl = $rootScope.urlConfig.msgCenterUrl;
            var TimeUrl = $rootScope.urlConfig.TimeUrl;
            var frdecrUrl = $rootScope.urlConfig.frdecrUrl;
            var stampUrl = $rootScope.urlConfig.stampUrl;

            var generate = function (action, urlType) {
                if (action == null)
                    return null;
                switch (urlType) {
                    case undefined:
                    case 'serverUrl':
                        var ret = serverUrl + action;
                        return ret;
                    case 'cloudCertUrl':
                        var ret = cloudCertUrl + action;
                        return ret;
                    case 'doDecDataUrl':
                        var ret = doDecDataUrl + action;
                        return ret;
                    case 'authCenterUrl':
                        var ret = authCenterUrl + action;
                        return ret;
                    case 'scanUrl':
                        var ret = scanUrl + action;
                        return ret;
                    case 'OCRUrl':
                        var ret = OCRUrl + action;
                        return ret;
                    case 'CTIDAuthUrl':
                        var ret = CTIDAuthUrl + action;
                        return ret;
                    case 'msgCenterUrl':
                        var ret = msgCenterUrl + action;
                        return ret;
                    case 'TimeUrl':
                        var ret = TimeUrl + action;
                        return ret;
                    case 'frdecrUrl':
                        var ret = frdecrUrl + action;
                        return ret;
                    case 'stampUrl':
                        var ret = stampUrl + action;
                        return ret;
                }
            }

            return {
                generate: generate
            };
        }]);
})();
