﻿(function () {
    "use strict"

    angular.module('starter')
    .filter("highlight", function ($sce, $log) {

        var fn = function (text, search) {
            $log.info("text: " + text);
            $log.info("search: " + search);

            var isNumber = !isNaN(search);

            if (!search || isNumber) {
                return $sce.trustAsHtml(text);
            }
            text = encodeURI(text);
            search = encodeURI(search);

            var regex = new RegExp(search, 'gi')
            var result = text.replace(regex, '<em style="color:red;">$&</em>');
            result = decodeURI(result);
            $log.info("result: " + result);
            return $sce.trustAsHtml(result);
        };

        return fn;
    })
})();