(function () {
    "use strict"
    angular.module('starter')
        .controller('confirmPayInfo', ['$rootScope', '$scope', 'nav'
            , 'control', 'nativeHelper', '$state', function ($rootScope, $scope, nav, control,
                nativeHelper, $state) {

                $scope.payInfo = { name: $rootScope.certAnnualFeeInfo.operator, cardId: $rootScope.certAnnualFeeInfo.operatorid }

                //默认服务费设置
                var count = '1';
                $scope.oneYear = true;
                $scope.twoYear = false;

                $scope.yearLimit = function (state) {
                    switch (state) {
                        case 'oneYear':
                            count = '1';
                            $scope.oneYear = true;
                            $scope.twoYear = false;
                            break;
                        case 'twoYear':
                            count = '2';
                            $scope.oneYear = false;
                            $scope.twoYear = true;
                            break;
                    }
                }
                //生成业务单
                $scope.confirmPayInfo = function(name, cardId) {
                    if (null == name || "undefined" == typeof(name) || "" == name) {
                        control.showPopup("经办人姓名不能为空", 2000);
                        return;
                    }
                    if (null == cardId || "undefined" == typeof(cardId) || "" == cardId) {
                        control.showPopup("经办人身份证号码不能为空", 2000);
                        return;
                    }
                    if (cardId.length === 17) {
                        cardId += "X";
                    }
                    $rootScope.certAnnualFeeInfo.operator = name;
                    $rootScope.certAnnualFeeInfo.operatorid = cardId;
                    $rootScope.certAnnualFeeInfo.count = count;
                    nav.navigate('annualFeeInvoice');
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();
