(function() {
    "use strict"
    angular.module('starter').controller('applyCertSearch', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'localStorage','verifyIdentity', '$stateParams',
    function($rootScope, $scope, nav, control, nativeHelper,localStorage, verifyIdentity, $stateParams) {
 document.getElementById("heightF").style.height = document.documentElement.clientHeight+'px';
//        document.getElementById("heightF").style.height = window.screen.availHeight+'px';
        // var searchContent = $stateParams.searchContent;
        $scope.searchInfo = {
            'key':''
//          'key': '浙江省马昌群测试用企业'
        };
        
        $scope.authRecordList = [];

        $scope.searchHistoryLists = localStorage.getObject('searchHistoryInfoLists');
        if (JSON.stringify($scope.searchHistoryLists) == '{}') $scope.searchHistoryLists = [];
        //存储搜索历史记录
        var storageSearch=function(sName){
            if($scope.searchHistoryLists.length<6&&$scope.searchHistoryLists.indexOf(sName)<0){
            $scope.searchHistoryLists.unshift(sName);
            }else if($scope.searchHistoryLists.length>=6&&$scope.searchHistoryLists.indexOf(sName)<0){
            $scope.searchHistoryLists.pop();
            $scope.searchHistoryLists.unshift(sName);

            }else if($scope.searchHistoryLists.indexOf(sName)>=0){
                $scope.searchHistoryLists.splice($scope.searchHistoryLists.indexOf(sName),1);
                $scope.searchHistoryLists.unshift(sName);
            }
          localStorage.setObject('searchHistoryLists', $scope.searchHistoryLists);
        }

        //存储搜索历史记录 携带搜索信息
        var storageSearchInfo=function(searchInfo){
            // 去重
            $scope.searchHistoryLists = $scope.searchHistoryLists.filter(searchHistory => {
                return searchHistory.entName != searchInfo.entName;
            });
            console.log('after fiter - ' + JSON.stringify($scope.searchHistoryLists));
            console.log('after fiter length - ' + $scope.searchHistoryLists.length);

            // 限制10个
            if ($scope.searchHistoryLists.length >= 10) {
                $scope.searchHistoryLists.pop();
                $scope.searchHistoryLists.unshift(searchInfo);
            } else {
                $scope.searchHistoryLists.unshift(searchInfo);
            }

            localStorage.setObject('searchHistoryInfoLists', $scope.searchHistoryLists);
        }
        //搜索授权企业
        $scope.searchAuthorizeEnt = function(key) {
            control.showLoading();
//            var containCategory = ['010','011'];
            var containCategory = [];
            var params = [key,containCategory];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                if (result.success) {
                    storageSearchInfo(result.value);
                    $rootScope.searchResult = result.value;
                    nav.navigate('ableApplyCertInfo');
                }
                if (!result.success) {
                    control.showPopup(result.msg, 2000);
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };
            nativeHelper.searchAuthorizeEnt({
                data: params,
                success: successFunc,
                fail: failFunc
            });
            // nativeHelper.searchAuthorizeEnt({ data: params, success: successFunc, fail: failFunc });
        }

        $scope.navigate = function(state) {
            nav.navigate(state);
        };
                                                             
         $scope.navToAuthRecord = function(){
            //  if($scope.authorizedNum.validRecordNum > 0 ||($scope.authorizedNum.validRecordNum === 0 && $scope.authorizedNum.inCheckRecordNum === 0)){
            //     $rootScope.recordType = '1';
            //  }else{
            //     $rootScope.recordType = '0';
            //  }
            //  nav.navigate('authorizationRecord');

            $rootScope.recordType = '0';
            nav.navigate('authorizationRecord');
         }

      $scope.showRecord=false;
    //获取授权领证信息
    var checkAuthorizedNum = function(res) {
        
        if (res.success) {
            $scope.authRecordList = res.value.authRecordList;

            console.log('checkAuthorizedNum - ' + JSON.stringify(res));
            // if(res.value.validRecordNum+res.value.inCheckRecordNum>0){
            //     $scope.showRecord=true;
            //     $scope.authorizedNum = res.value;
            // }
            if(res.value.inCheckRecordNum>0){
                $scope.showRecord=true;
                $scope.authorizedNum = res.value;
            }


        } else {
            control.showPopup(res.msg, 2000);
        }
    }
    if($rootScope.loginInfo.realNameGrade=='1'){
        verifyIdentity.checkAuthorization($rootScope.loginInfo.idCard,'2','',checkAuthorizedNum);
    }


    $scope.isBlur=false;

    $scope.cleanClick = function() {
        var confirm = function () {
            localStorage.deleteItem('searchHistoryInfoLists');
            $scope.searchHistoryLists = [];
        };
        var cancel = function () {};
        control.showConfirm('确定要清空当前的搜索记录吗？', confirm, cancel);
    }

    $scope.searchHistoryClick = function(searchHistory) {
        $rootScope.searchResult = searchHistory;
        nav.navigate('ableApplyCertInfo');
    }

    $scope.moreClick = function() {
        console.log('moreClick');
        
        
        $rootScope.recordType = '1';
        nav.navigate('authorizationRecord');
    }

    $scope.getBlur=function(){
        if(cordova.platformId == 'android'){
        document.getElementById("lishilisth").style.height = 'auto'
        }
        $scope.isBlur=false;
    }
    $scope.getFocus=function(){
        if(cordova.platformId === 'android'){
        document.getElementById("lishilisth").style.height = '1000px'
        }
        $scope.isBlur=true;
    }
//    var eventWithParameters = function() {
//        var eventCounter = new Object();
//        eventCounter.page = "授权领证搜索页";
//        MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//    }
//    eventWithParameters();

//                            var pageBegin=function () {
//                                MobclickAgent.onPageBegin("授权搜索页面");
//                            }
//                            pageBegin();
//                                var pageEnd=function () {
//                                MobclickAgent.onPageEnd("离开授权搜索页面");
//                            }
//                            pageEnd();
    }]);
})();
