(function () {
    "use strict"

    angular.module('starter')
        .controller('legalRepresentative', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$state', 'localStorage', '$ionicHistory','verifyIdentity',
        function ($rootScope, $scope, nav, control, nativeHelper, $state, localStorage, $ionicHistory,verifyIdentity) {

        $scope.represent={type:''}

                var operatorType;

                switch($rootScope.certUnderwayInfo.identityType){
                case '0':
                $scope.represent.type='法定代表人';
                operatorType='0'
                break;
                case '1':
                $scope.represent.type='管理员';
                operatorType='2';
                break;
                case '2':
                operatorType='1';
                break;
                }

            //生成业务单
            var doNetOrderInfo = function() {
            control.showLoading();

            var params = [$rootScope.loginInfo.userName, $rootScope.loginInfo.idCard,
            $rootScope.loginInfo.mobile, $rootScope.loginInfo.accountId,
            $rootScope.certUnderwayInfo.corpid, $rootScope.certUnderwayInfo.categoryBh,
            $rootScope.certUnderwayInfo.netType, {
                'letter': '',
                'idCardFace':"data:image/png;base64,"+$rootScope.certUnderwayInfo.base64PhotoData
            },
            'EPASSAPP',
            '',
            operatorType];
            var successFunc = function(result) {
                $scope.canClick=false;
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                 if (result.success) {
                //0：法人 1:经办人
                $scope.$apply(function(){
                        $rootScope.certUnderwayInfo.orderNo=result.value.orderNo;
                        $rootScope.certUnderwayInfo.orderType='1';
                        $state.go('downloadCert',{'downloadCertInfo':$rootScope.certUnderwayInfo});
                });
                }
                if (!result.success) {
                    control.showPopup(result.msg, 2000);
                }
            }
            var failFunc = function(error) {
                $scope.canClick=false;
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };

            nativeHelper.doSaveAuthNetOrderInfo({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
//     32   "identityType": "0法定代表人1管理员2经办人",
            $scope.canClick=false;
            $scope.createBusinessOrder=function(){
                isAuth = false;
                $scope.canClick=true;
                if ($rootScope.certUnderwayInfo.businessCode == 'P012' && !$rootScope.certUnderwayInfo.isFree) {
                        $state.go('confirmCertInvoice',{'netOrderInfoWithInvoice':{
                        'entName':$rootScope.certUnderwayInfo.entName,
                        'uniscid':$rootScope.certUnderwayInfo.uniscid,
                        'agenter':$rootScope.loginInfo.userName,
                        'cert':$rootScope.loginInfo.idCard,
                        'mobile':$rootScope.loginInfo.mobile,
                        'corpid':$rootScope.certUnderwayInfo.corpid,
                        'categoryBh':$rootScope.certUnderwayInfo.categoryBh,
                        'netType':$rootScope.certUnderwayInfo.netType,
                        'letter':'',
                        'idCardFace':$rootScope.certUnderwayInfo.base64PhotoData,
                        'authId':$rootScope.certUnderwayInfo.identityId,
                        'operatorType':operatorType,
                        'businessCode':$rootScope.certUnderwayInfo.businessCode,
                        'orderType':'1',
                        }});
                        return;
                }
                $scope.alert_applicant_info=true;
            }

           //实人检测错误提示
            var detectionError = function(resultMsg) {
                if (liveDetectionNum < $rootScope.authFaceMax) {
                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                    control.showConfirm3($scope.startBiopsy,
                    function() {},
                    '取消', '重试', 'check-information', template);
                    return;
                } else if (liveDetectionNum === $rootScope.authFaceMax) {
                    liveDetectionNum = 0;
                    var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                    control.showConfirm3(function() {
                        $rootScope.isNeedAuthFace = false;
                        $scope.navigate('userNotice')
                    },
                    function() {
                        $rootScope.isNeedAuthFace = true;
                        nav.go('home');
                        return;
                    },
                    '返回首页', '上传材料', 'check-information', template);
                    return;
                }
            }
            //采集人脸提示
            $scope.alert_applicant_info = false;
            $scope.closeApplicantInfoAlert = function() {
                $scope.alert_applicant_info = false;
            }
            //记录刷脸次数
            var liveDetectionNum=0;
            
            //点击我要授权
            var isAuth = false;

            //开始活体检测
            $scope.startBiopsyClick=function(){
                $scope.alert_applicant_info=false;
                $scope.acShowAuthConfirm = true;
            }
            
            var authLivingFailEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体识别失败";
                MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
            }


            var startBiopsy = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体检测-法人下载";
                MobclickAgent.onEventWithParameters("authLivingLegalPersonEvent", eventCounter);
               if (isAuth) {
                   startBiopsyForAuthorization();
               } else {
                   $scope.alert_applicant_info=false;
                   liveDetectionNum++;
                   verifyIdentity.startLiveDetection(liveDetectionResult);
               }
            }


            $scope.acShowAuthConfirm = false;
            $scope.acCloseClick = function() {
                $scope.acShowAuthConfirm = false;
            }
            $scope.acIsAgreeApplyAgreement = true;
            $scope.acAgree = function() {
                $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
            }
            $scope.acAgreement = function() {
                var url = window.currentUrl + '/app/api/appfaceagreement';
                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }
            $scope.acNext = function() {
                if (!$scope.acIsAgreeApplyAgreement) {
                    control.showPopup("请先阅读协议并同意", 2000);
                    return;
                }
                $scope.acShowAuthConfirm = false;
                startBiopsy();
            }

            //人脸识别结果监听
            var liveDetectionResult = function(res) {
                $scope.$apply(function() {
                    if (res.base64PhotoData) {
                        var photoData = res.base64PhotoData;
                        $rootScope.certUnderwayInfo.base64PhotoData = photoData;
                        verifyIdentity.startIdentityAuthenticationAction($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, photoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, IdentityAuthenticationRes);
                    } else {
                        authLivingFailEvent();
                        detectionError(res.resultMsg);

                    }
                });
            };

            //人脸信息和身份信息对比结果
            var IdentityAuthenticationRes = function(data) {
                $scope.$apply(function() {
                    if (data.result == 'fail') {
                         if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                             detectionError('姓名或身份证号码有误，错误代码'+data.authResult);
                             return;
                         } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                             detectionError('人脸比对失败，错误代码'+data.authResult);
                             return;
                         } else {control.showPopup(data.authResultMsg, 2000);}
//                        if (data.authResult == '5XXX' || data.authResult == '6XXX' || data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '0FXX') {
//
//                            detectionError(data.authResultMsg);
//                            return;
//                        } else{
//                            control.showPopup(data.authResultMsg, 2000);
//                        }
                    }
                    if (data.result == 'success') {
                        //生成业务单
                        doNetOrderInfo();
                    }
                });
            }


            $scope.doGetUserFace = function () {
                control.showLoading();
                var params = [$rootScope.loginInfo.idCard];
                var successFunc = function(result) {
                    control.hideLoading();
                    console.log('doGetUserFace result -- ' + JSON.stringify(result));
                    
                    if ('success' == result.rslt) {
                        // 都做人脸识别
                        // let hasFaceImg = String(result.data.hasFaceImg);
                        // if ('0' == hasFaceImg) {
                            isAuth = true;
                            $scope.alert_applicant_info=true;
                        // } else if ('1' == hasFaceImg) {
                        //     nav.navigate('selectHandler');
                        // }
                    } else {
                        control.showPopup(error, 3000);
                    }
                }
                var failFunc = function(error) {
                    control.hideLoading();
                    control.showPopup(error, 3000);
                };
                nativeHelper.getUserFace({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }


        //开始活体检测
        var startBiopsyForAuthorization=function(){
            isAuth = false;
            $scope.alert_applicant_info=false;
            verifyIdentity.startLiveDetection(liveDetectionResultForAuthorization);
        }
        var photoData;
        //人脸识别结果监听
        var liveDetectionResultForAuthorization = function(res) {
            $scope.$apply(function() {
                if (res.base64PhotoData) {
                    photoData = res.base64PhotoData;
                    verifyIdentity.startIdentityAuthenticationAction($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, photoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, IdentityAuthenticationResForAuthorization);
                } else {
                    authLivingFailEvent();
                    detectionErrorForAuthorization(res.resultMsg);

                }
            });
        };
        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
        //实人检测错误提示
        var detectionErrorForAuthorization = function(resultMsg) {
            // if (liveDetectionNum < $rootScope.authFaceMax) {
                var template = "<div><i class='icon-tips2'></i><h3>识别失败</h3><p>" + resultMsg + "</p></div>";
                control.showConfirm3(startBiopsyForAuthorization,
                    function() {},
                '取消', '重试', 'check-information', template);
                return;
            // } else if (liveDetectionNum === $rootScope.authFaceMax) {
            //     liveDetectionNum=0;
            //     control.showPopup("人脸识别失败，请返回首页后重新操作", 2500);
            //     nav.go('home');
            // }
        }
        //人脸信息和身份信息对比结果
        var IdentityAuthenticationResForAuthorization = function(data) {
            $scope.$apply(function() {
                if (data.result == 'fail') {
                    if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                         detectionErrorForAuthorization('姓名或身份证号码有误，错误代码'+data.authResult);
                         return;
                    } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult ==  '02XX'){
                         detectionErrorForAuthorization('人脸比对失败，错误代码'+data.authResult);
                         return;
                    } else {control.showPopup(data.authResultMsg, 2000);}
                }

                nav.navigate('selectHandler');
            });
        }
        







            $scope.navigate = function (state) {
                nav.navigate(state);
            };
            $scope.goBack=function(){
                $ionicHistory.goBack();
            }
//            var eventWithParameters = function() {
//                var eventCounter = new Object();
//                eventCounter.page = "法定代表人";
//                MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//            }
//            eventWithParameters();
        }]);
})();
