(function() {
    "use strict"
    angular.module('starter').controller('orderInfoConfirm', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$stateParams', '$state',
    function($rootScope, $scope, nav, control, nativeHelper, $stateParams, $state) {
        control.hideLoading();
        //获取付费数据信息
        $scope.orderInfo = $stateParams.orderInfo;
        //支付订单
        $scope.paymentOrder = function() {
            control.showLoading();

            var params = [$rootScope.loginInfo.accountId, $scope.orderInfo.orderNo];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                if (result.resultStatus == 9000) {
                    //授权申领成功父页面
                    // $rootScope.applyCompleteParent='confirmAuthorizeInfo';
//                    $rootScope.certUnderwayInfo.orderNo=$scope.orderInfo.orderNo;
                      $scope.orderInfo.orderType='1';
                                            $state.go('downloadCert',{'downloadCertInfo': $scope.orderInfo});
                }
                if (result.resultStatus != 9000) {
                    if (cordova.platformId === 'android') {
                        control.showPopup('支付失败：' + result.resultMsg, 2000);
                    } else control.showPopup('支付失败：' + result.resultStatus, 2000);
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.memo, 2000);
            };

            nativeHelper.paymentOrder({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

        var payCallback = function(e) {
            control.hideLoading();
            if (e.resultStatus == 9000) {
                //授权申领成功父页面
                //$rootScope.applyCompleteParent='confirmAuthorizeInfo';
//                $state.go('applyCertComplete');
                  $scope.orderInfo.orderType='1';
                  $state.go('downloadCert',{'downloadCertInfo': $scope.orderInfo});
            }
            if (e.resultStatus != 9000) {
                control.showPopup(e.memo + e.resultStatus, 2000);
            }
        };
                                                              
        var hideLoading = function(e) {
           control.hideLoading();
        };

        if (cordova.platformId === 'ios') {
           window.broadcaster.addEventListener("payCallback", payCallback);

           window.broadcaster.addEventListener("hideLoading", hideLoading);
        }

        $scope.navigate = function(state) {
            nav.goBack();
//            nav.navigate(state);
        };

    }]);
})();
