﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('checkBusinessLicense', ['$rootScope', '$scope', 'nav', 'control', 'utility', function ($rootScope, $scope, nav, control, utility) {
            $scope.isShowPhotoRules = false;

            $scope.checkPicture = function () {
                var successFunc = function (pic) {
                  $scope.$apply(function () {
                    control.hideLoading();
                    $rootScope.autoApplyInfo.businessLicensePic = 'data:image/png;base64,' + pic;
//                    console.log("yzz"+$rootScope.autoApplyInfo.businessLicensePic);
                    });
                };

                var failFunc = function (e) {
                    control.hideLoading();
                };

                control.camera(successFunc, failFunc, false);
            }

            $scope.next = function () {

                if ($rootScope.autoApplyInfo.businessLicensePic == '') {
                        control.showPopup('请上传图片', 2000);
                    return;
                }

                    $rootScope.autoApplyInfo.businessLicenseEntName = $rootScope.certUnderwayInfo.entName;
                    nav.navigate('checkAuthorization');
            }

            $scope.showPhotoRules = function () {
                $scope.isShowPhotoRules = true;
            }

            $scope.hidePhotoRules = function () {
                $scope.isShowPhotoRules = false;
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();