﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('uploadBusinessLicense', ['$rootScope', '$scope', 'nav', 'control', 'utility', function ($rootScope, $scope, nav, control, utility) {
            $scope.isShowPhotoRules = false;

            $scope.backbtnClick = function () {
                console.log('$rootScope.updatePictures.uploadFrom '+ $rootScope.updatePictures.uploadFrom);
                nav.navigate($rootScope.updatePictures.uploadFrom);
            }

            $scope.checkPicture = function () {
                var successFunc = function (pic) {
                  $scope.$apply(function () {
                        control.hideLoading();
                        $rootScope.updatePictures.businessLicensePic = 'data:image/png;base64,' + pic;
                    });
                };

                var failFunc = function (e) {
                    control.hideLoading();
                };

                control.camera(successFunc, failFunc, false);
            }

            $scope.next = function () {
                console.log("$rootScope.updatePictures.businessLicensePic" );

                if ($rootScope.updatePictures.businessLicensePic == '') {
                    control.showPopup('请上传图片', 2000);
                    return;
                }

                nav.navigate('uploadIdentityCard');
            }

            $scope.showPhotoRules = function () {
                $scope.isShowPhotoRules = true;
            }

            $scope.hidePhotoRules = function () {
                $scope.isShowPhotoRules = false;
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
        }]);
})();