(function () {
    "use strict"
    angular.module('starter')
        .controller('uploadIdentityCard', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'utility', 'verifyIdentity','$state','localStorage', 'requestWrapper', 'md5',function ($rootScope, $scope, nav, control, nativeHelper, utility,verifyIdentity,$state,localStorage, requestWrapper, md5) {

           if(cordova.platformId==='android'){
                $scope.isAndroid=true;
           }else{
                $scope.isAndroid=false;
           }
        $scope.checkPicture = function (type) {

            var successFunc = function (pic) {
                control.hideLoading();
                if(type=="1"){
                    $rootScope.updatePictures.IDCardFrontPic = 'data:image/png;base64,' + pic;
                }else if(type=="2"){
                    $scope.$apply(function () {
                    $rootScope.updatePictures.IDCardBackPic = 'data:image/png;base64,' + pic;
                    });
                }
            };

            var failFunc = function (e) {
                control.hideLoading();
            };
            control.camera(successFunc, failFunc, false);
        }

            
            

        $scope.checkIdentityCard={IDCardName:$rootScope.loginInfo.userName?$rootScope.loginInfo.userName:'',IDCardNumber:$rootScope.loginInfo.idCard?$rootScope.loginInfo.idCard:''}
        $scope.inputable=false;//默认允许输入框可输入
        if($rootScope.loginInfo.userName){
            $scope.inputable=true;
        }
            
        $scope.alert_applicant_info=false;
        $scope.next = function () {
            if ($rootScope.updatePictures.IDCardFrontPic == '' || $rootScope.updatePictures.IDCardBackPic == '') {
                control.showPopup("请上传身份证正反面", 2000);
                return;
            }

            if ($scope.checkIdentityCard.IDCardName == '') {
                control.showPopup("姓名错误请修改", 2000);
                $scope.isClicked = false;
                return;
            }

            if ($scope.checkIdentityCard.IDCardNumber == '') {
                control.showPopup("身份证号码错误请修改", 2000);

                return;
            }
            if($scope.checkIdentityCard.IDCardNumber.length===17){
                $scope.checkIdentityCard.IDCardNumber+="X";
            }
            if($rootScope.updatePictures.IDCardIndate)
            var expireDate = $rootScope.updatePictures.IDCardIndate;
            expireDate = expireDate + ' 23:59:59';
            expireDate = new Date(expireDate);
            if (expireDate < new Date()) {
                $rootScope.OCRFailMsg = '身份证过期，请重新上传';
                $rootScope.OCRFail();
                $scope.isClicked = false;
                return;
            }

            if ('businessManage' == $rootScope.updatePictures.uploadFrom) {
                doUploadEntPic();
            } else {
                nav.navigate($rootScope.updatePictures.uploadFrom);
            }
        }

        var doUploadEntPic = function () {
            control.showLoading();
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
            var params = {
                'appid': $rootScope.appid,
                'time': time,
                'hashdata': hashdata,
                'orderNo': $rootScope.updatePictures.orderNo,
                'idCardFaceBase64': $rootScope.updatePictures.IDCardBackPic,
                'idCardBackBase64': $rootScope.updatePictures.IDCardFrontPic,
                'businessLinceBase64': $rootScope.updatePictures.businessLicensePic,
                'faceAuthBase64': $rootScope.updatePictures.authorizationPic,
            }
            requestWrapper.doUploadEntPic({data: params, refresh: true})
                .then(function (result) {
                    control.hideLoading();
                    if (true == result.success) {
                        nav.navigate($rootScope.updatePictures.uploadFrom);
                    } else {
                        control.showPopup(result.msg, 2000);
                    }
                });
        }



        $scope.closeApplicantInfoAlert=function(){
            $scope.alert_applicant_info=false;
        }


        $scope.showPhotoRules = function() {
            $scope.isShowPhotoRules = true;
        }

        $scope.hidePhotoRules = function() {
            $scope.isShowPhotoRules = false;
        }

        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
