(function () {
    "use strict"

    angular.module('starter')
        .controller('eleBusinessLicense', ['$ionicActionSheet', '$rootScope', '$scope', 'control', 'nav',
            'nativeHelper', '$state', function ($ionicActionSheet, $rootScope, $scope, control, nav,
                nativeHelper, $state) {
                $rootScope.timer='defined';
//                            $scope.licenseLists = [{
//                                entName: '汇信科技', uniscid: 2365236523652365236
//                            }, {
//                                    entName: '汇信科技', uniscid: 2365236523652365236
//                                }, {
//                                    entName: '汇信科技', uniscid: 2365236523652365236
//                                }, {
//                                    entName: '汇信科技', uniscid: 2365236523652365236
//                                }];

                /**
                 * 获取电子营业执照企业列表信息
                 * */
                var getEleBusinessLicenseList = function () {

                    control.showLoading();
                    var params = [$rootScope.loginInfo.accountId];
                    var successFunc = function (result) {

                        control.hideLoading();
                        if (result == null || angular.equals([], result)) {
                            $scope.licenseLists = [];
                            return;
                        }

                        if (result.rslt =='success') {
                            $scope.licenseLists = result.elicenseList;
                        } else {
                            control.showPopup(result.errorMsg, 2000);
                            $scope.licenseLists = [];
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                        $scope.licenseLists = [];
                    };

                    nativeHelper.getEleBusinessLicenseList({ data: params, success: successFunc, fail: failFunc });
                }
                getEleBusinessLicenseList();

                $scope.navToSee = function (item) {
                    $rootScope.unitName=item.unitName;
                    $rootScope.uniscid=item.uniscid;
                    $rootScope.id=item.id;
                    nav.navigate('viewBusinessLicense');
                }
                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();
