(function() {
    "use strict"
    angular.module('starter')
    .controller('subjectQuery', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'localStorage', 'verifyIdentity',
    function($rootScope, $scope, nav, control, nativeHelper, localStorage, verifyIdentity) {
//    document.getElementById("heightF").style.height = window.screen.availHeight+'px';
        document.getElementById("heightF").style.height = document.documentElement.clientHeight+'px';
        $scope.searchInfo = {
            'key': ''
        };
        $scope.authRecordList = [];

           $scope.isBlur=false;
           $scope.getBlur=function(){
                if(cordova.platformId == 'android'){
                document.getElementById("lishilisth").style.height = 'auto'
                }
               $scope.isBlur=false;
           }
           $scope.getFocus=function(){
                if(cordova.platformId === 'android'){
                document.getElementById("lishilisth").style.height = '1000px'
                }
               $scope.isBlur=true;
           }
        $scope.searchHistoryLists = localStorage.getObject('searchHistoryInfoLists');
        if (JSON.stringify($scope.searchHistoryLists) == '{}') $scope.searchHistoryLists = [];

         //存储搜索记录
        var storageSearch = function(sName) {
            if ($scope.searchHistoryLists.length < 6 && $scope.searchHistoryLists.indexOf(sName) < 0) {
                $scope.searchHistoryLists.unshift(sName);
            } else if ($scope.searchHistoryLists.length >= 6 && $scope.searchHistoryLists.indexOf(sName) < 0) {
                $scope.searchHistoryLists.pop();
                $scope.searchHistoryLists.unshift(sName);

            } else if ($scope.searchHistoryLists.indexOf(sName) >= 0) {
                $scope.searchHistoryLists.splice($scope.searchHistoryLists.indexOf(sName), 1);
                $scope.searchHistoryLists.unshift(sName);
            }
            localStorage.setObject('searchHistoryLists', $scope.searchHistoryLists);
        }

        //存储搜索历史记录 携带搜索信息
        var storageSearchInfo=function(searchInfo){
            // 去重
            $scope.searchHistoryLists = $scope.searchHistoryLists.filter(searchHistory => {
                return searchHistory.entName != searchInfo.entName;
            });
            console.log('after fiter - ' + JSON.stringify($scope.searchHistoryLists));
            console.log('after fiter length - ' + $scope.searchHistoryLists.length);

            // 限制10个
            if ($scope.searchHistoryLists.length >= 10) {
                $scope.searchHistoryLists.pop();
                $scope.searchHistoryLists.unshift(searchInfo);
            } else {
                $scope.searchHistoryLists.unshift(searchInfo);
            }

            localStorage.setObject('searchHistoryInfoLists', $scope.searchHistoryLists);
        }

        $rootScope.isAutoApply = true;
        //主体查询搜索方法
        $scope.searchSelect = function(key) {
            control.showLoading();

            // storageSearch(key);
            /**
             * onlyFrz  是否只有法人证 为false时不过滤收费证书 新版本传false
             * */
            var params = [key, false, $rootScope.loginInfo.mobile];
            var successFunc = function(result) {
                control.hideLoading();
                
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.success) {
                    storageSearchInfo(result.value);
                    $rootScope.searchResult = result.value;

                    nav.navigate('reissueOrGetNewCert');

                }
                if (!result.success) {
                    control.showPopup(result.msg, 3000);
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 3000);
            };

            nativeHelper.getSubjectQuerySearch({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
         $scope.showRecord=false;
        //获取授权领证信息
        var checkAuthorizedNum = function(res) {
            if (res.success) {
                $scope.authRecordList = res.value.authRecordList;
    
                // console.log('checkAuthorizedNum - ' + JSON.stringify(res));
                // if(res.value.validRecordNum+res.value.inCheckRecordNum>0){
                //     $scope.showRecord=true;
                //     $scope.authorizedNum = res.value;
                // }
                if(res.value.inCheckRecordNum>0){
                    $scope.showRecord=true;
                    $scope.authorizedNum = res.value;
                }
    
            } else {
                control.showPopup(res.msg, 2000);
            }
        }
        if ($rootScope.loginInfo.realNameGrade == '1') {
            verifyIdentity.checkAuthorization($rootScope.loginInfo.idCard, '2', '', checkAuthorizedNum);
        }
        $scope.navToAuthRecord = function(){
             if($scope.authorizedNum.validRecordNum > 0 ||($scope.authorizedNum.validRecordNum === 0 && $scope.authorizedNum.inCheckRecordNum === 0)){
                $rootScope.recordType = '1';
             }else{
                $rootScope.recordType = '0';
             }
             nav.navigate('authorizationRecord');
        }
        $scope.navigate = function(state) {
            nav.navigate(state);
        };


        $scope.moreClick = function() {
            console.log('moreClick');
            $rootScope.recordType = '1';
            nav.navigate('authorizationRecord');
        }

        $scope.cleanClick = function() {
            var confirm = function () {
                localStorage.deleteItem('searchHistoryInfoLists');
                $scope.searchHistoryLists = [];
            };
            var cancel = function () {};
            control.showConfirm('确定要清空当前的搜索记录吗？', confirm, cancel);
        }

        $scope.searchHistoryClick = function(searchHistory) {
            $rootScope.searchResult = searchHistory;
            nav.navigate('reissueOrGetNewCert');
        }

//        var eventWithParameters = function() {
//                var eventCounter = new Object();
//                eventCounter.page = "材料领证搜索页";
//                MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//            }
//            eventWithParameters();

    }]);
})();
