﻿(function () {
    "use strict"

    angular.module('starter')
    .filter('datetime', [function () {
        var mvcDatePattern = /Date\(([^)]+)\)/;
        return function (input, format) {
            if (!input)
                return '';

            if (typeof format == 'undefined') {
                format = 'YYYY-MM-DD';
            }

            if (angular.isString(input) && mvcDatePattern.test(input))
                input = parseFloat(mvcDatePattern.exec(input)[1]);

            return moment.utc(input).locale('zh').format(format);
        };
    }]);
})();