﻿(function () {
    "use strict"

    angular.module('starter')
    .filter('money', ['validate', function (validate) {
        return function (input, format) {
            if (typeof format == 'undefined') {
                format = 2;
            }

            if (validate.nullOrEmpty(input)) {
                return parseFloat('0').toFixed(format)
            }
            else {
                return parseFloat(input).toFixed(format);
            }
        };
    }]);
})();